#include "common.h"
#include "tdrocr.h"
#include "utils.h"


#define ROI_ANGLE_VALUE 0  // 0.5

int process_indeterminacy_rect_back(vector<Rect>& longRects,
                                    vector<Rect>& indeterminacy_rect,
                                    int char_dist, int minLinew);

/*************************************************
Function:       rectSelect
Description:
    根据名称字符行的高度、形状、位置特征，先找到名称字符行，再根据名称字符行
与其他有效字符行的位置关系，筛选出其他有效字符行。
    根据卡片类型进行筛选，若是筛选的信息不全，也视为操作失败。

Input:          src: 卡片信息彩色图像。
                lineRect: 提供所有可用的待选字符行。
                lineRect_select: 存储返回的定位到的有效字符行信息。
                cardClass:卡片类型标识。1=FROM_TW, 2=TO_HK。
                camera: 0新旧摄像头标识。1是旧摄像头。

Return:         成功返回0， 失败返回-1。
*************************************************/
int rectSelect(Mat& src, vector<Rect>& lineRect, vector<Rect>& lineRect_select, int cardClass, int camera) {
  int birthyoff1 = 130;int sexxoff1 = 235;int sexyoff1 = 130;int valiyoff1 = 200;
  int birthyoff2 = 116;int sexxoff2 = 324;int sexyoff2 = 116;int valiyoff2 = 188; int idyoff2 = 330;
  if(camera == 1)
  {
     birthyoff1 = 154;sexxoff1 = 272;sexyoff1 = 154; valiyoff1 = 238;
     birthyoff2 = 134;sexxoff2 = 370;sexyoff2 = 134;valiyoff2 = 216;idyoff2 = 382;
  }
  ////cout<<"aaaaaaaaaaaaaaaaaaa"<<lineRect.size()<<endl;
  /// cardClass: 1 is FROM_TW, 2 is TO_HK
  if (cardClass == 1 && lineRect.size()<5) return -1;
  if (cardClass == 2 && lineRect.size()<4) return -1;
  int ret = 0;
  
/*
    for(int i=0;i<lineRect.size();i++)
  {
     //cout <<lineRect[i].x<<" "<<lineRect[i].y<<" "<< lineRect[i].width<<" "<<lineRect[i].height<< endl;
  }
  //cout<<src.cols<<" "<<src.rows<<endl;
*/
  for (int i=0; i< lineRect.size();i++) {
    if (lineRect[i].width*lineRect[i].height==0) return -1;
    lineRect[i].x -= 5;
    lineRect[i].width += 10;
    lineRect[i].y -= 5;
    lineRect[i].height += 10;
    lineRect[i].x = max(0, lineRect[i].x);
    lineRect[i].y = max(0, lineRect[i].y);
    lineRect[i].width = min(lineRect[i].width, src.cols - lineRect[i].x - 1);
    lineRect[i].height = min(lineRect[i].height, src.rows - lineRect[i].y - 1);
	}
	//	Mat img = src.clone();
  ////cout << lineRect.size() << endl;
  /////// for (int i=0; i< lineRect.size();i++) {
  //   //////////////cout << lineRect[i].x << " " << lineRect[i].y << " " << lineRect[i].width << " " << lineRect[i].height << " "<< i << endl;
	//////// 	rectangle(img, lineRect[i], Scalar(0),1, LINE_8, 0);
	// }
	////// //imshow("img", img);
	//////////waitkey(0);


  sort(lineRect.begin(), lineRect.end(), comp_y);

  Rect rect_name, rect_sex, rect_birthday, rect_valid_from_to, rect_id, rect_mrz;
  // for (int i=0; i< lineRect.size();i++) {
  //   if (lineRect[i].y>380 && lineRect[i].width>650 && lineRect[i].height>20) {
  //     rect_mrz = lineRect[i];
  //     selectNum++;
  //     break;
  //   }
  // }
// TODO 必须有，否则有些图识别不过，似乎检测框不能太小
  for (int i=0; i< lineRect.size();i++) {
    //if (lineRect[i].width>60) {
    if (lineRect[i].width>60&&lineRect[i].height>20&&lineRect[i].x > 220) {
      rect_name = lineRect[i];
      rect_name.width+=60;
      break;
    }
  }
  ////cout<<"rect name is "<<rect_name.width<<" "<<rect_name.width<<endl;
  int offset_x = 42, offset_y = 17;
  if (cardClass == 2 && rect_name.width>0 && rect_name.height>0) {
    int x = rect_name.x;
    int y = rect_name.y;
    for (int i=1; i< lineRect.size();i++) {
      if (abs(lineRect[i].x-x)<offset_x && abs(lineRect[i].y-y-birthyoff1)<offset_y) {
        rect_birthday = lineRect[i]; //birthday: 1
      }
      if (abs(lineRect[i].x-x-sexxoff1)<offset_x && abs(lineRect[i].y-y-sexyoff1)<offset_y) {
        rect_sex = lineRect[i]; // sex: 2
      }
      if (abs(lineRect[i].x-x)<offset_x && abs(lineRect[i].y-y-valiyoff1)<offset_y) {
        rect_valid_from_to = lineRect[i]; //valid_from_to: 3
      }
    }
  }

  else if (cardClass == 1 && rect_name.width>0 && rect_name.height>0) {
    int x = rect_name.x;
    int y = rect_name.y;
    for (int i=1; i< lineRect.size();i++) {
      if (abs(lineRect[i].x-x)<offset_x && abs(lineRect[i].y-y-birthyoff2)<offset_y) {
        rect_birthday = lineRect[i]; //birthday: 1

      }
      if (abs(lineRect[i].x-x-sexxoff2)<offset_x && abs(lineRect[i].y-y-sexyoff2)<offset_y) {
        rect_sex = lineRect[i]; // sex: 2
      }
      if (abs(lineRect[i].x-x)<offset_x && abs(lineRect[i].y-y-valiyoff2)<offset_y) {
        rect_valid_from_to = lineRect[i]; //valid_from_to: 3
      }
      if (abs(lineRect[i].x-x)<offset_x && abs(lineRect[i].y-y-idyoff2)<offset_y) {
        rect_id = lineRect[i]; //id: 4
      }
    }
  }
  vector<Rect> lineRect_tmp;
  if (rect_name.width>0 && rect_name.height>0) {
    lineRect_tmp.push_back(rect_name); //name: 0
  }
  if (rect_birthday.width>0 && rect_birthday.height>0) {
    lineRect_tmp.push_back(rect_birthday); //birthday: 1
  }
  if (rect_sex.width>0 && rect_sex.height>0) {
    lineRect_tmp.push_back(rect_sex); // sex: 2
  }
  if (rect_valid_from_to.width>0 && rect_valid_from_to.height>0) {
#ifdef TDR_TRACE
    //printf("rect_valid_from_to.width=%d\n", rect_valid_from_to.width);
#endif
    if(rect_valid_from_to.width<300) return -1;  //www
    lineRect_tmp.push_back(rect_valid_from_to); //valid_from_to: 3
  }
  if (rect_id.width>0 && rect_id.height>0) {
    lineRect_tmp.push_back(rect_id); //id: 4
  }
  lineRect_select.assign(lineRect_tmp.begin(), lineRect_tmp.end());
  if (cardClass == 1 && lineRect_select.size()!=5) return -1;
  if (cardClass == 2 && lineRect_select.size()!=4) return -1;
  return ret;
}

/*************************************************
Function:       pointRot
Description:    获取图像上某一点，经过旋转后映射到坐标

Input:          pt: 目标点。
                rows: 求旋转中心点的矩形高。
                cols: 求旋转中心点的矩形宽。
                angle:旋转的角度（以弧度为单位）。
Return:         旋转后映射点点坐标。
*************************************************/
cv::Point pointRot(cv::Point pt,int rows,int cols,float angle)
{
	Point2f center = Point2f(cols/2,rows/2);
	Mat rotH = cv::getRotationMatrix2D(center,angle,1);
	cv::Point rslt;

	rslt.x = rotH.ptr<double>(0)[0]*pt.x + rotH.ptr<double>(0)[1]*pt.y + rotH.ptr<double>(0)[2];
	rslt.y = rotH.ptr<double>(1)[0]*pt.x + rotH.ptr<double>(1)[1]*pt.y + rotH.ptr<double>(1)[2];

	return rslt;
}

/*************************************************
Function:       lineSelect1
Description:
    使用detectRegions方法查找有效字符轮廓，通过闭操作获取所有字符行。
	根据首行卡片类型字符行的中心点y坐标，筛选出符合位置关系的待选字符行。
    此时的字符行可能有因分割效果不好而粘连的情况，使用逐行扫描计算白点的有效占比的方法
重新筛选异常行，并获得所有可用的待选字符行。
    最后使用 rectSelect方法，从所有待选字符行中，筛选有效字符行。

Calls:          rectSelect：从所有待选字符行中，筛选有效字符行。

Input:          src: 卡片信息彩色图像。
                gray: src缩小一半的灰度图。
                linesSelect: 存储返回的定位到的有效字符行信息。
                ptrMSER1:固定参数的cv::MSER实例句柄，有外层调用函数负责设置。
                scale_800: src与gray的比例关系
                newy:
  首行卡片类型字符行的中心点y坐标，用来辅助定位后续字符行的有效位置。
                cardClass:卡片类型标识。1=FROM_TW, 2=TO_HK。
                camera: 新旧摄像头标识。1是旧摄像头。

Return:         成功返回0， 失败返回-1。
*************************************************/
int lineSelect1(Mat& src, Mat& gray, vector<Rect>& linesSelect, cv::Ptr<cv::MSER>& ptrMSER1, int scale_800, int newy, int cardClass, int camera) 
{
//return 0;
    int newyoff = 20;
    int maxRecth = 55;int maxRectw = 130;int maxRectr = 340;
    int summin = 30;
    int minArh1 = 20;int minArw1 = 150;
    int minArh2 = 20;int maxArw2 = 140;int maxArh2 = 35;
    int broff = 18;
    int minArh3 = 55;
    int minRectch = 40;
    int minLinew = 20;int minLineh = 20;int minLinex = 220;
    int birthyoff1 = 130;int valiyoff1 = 200;
    int birthyoff2 = 116;int valiyoff2 = 188;int idyoff2 = 330;
    if(camera == 1)
    {
       newyoff = 25;
       maxRecth = 60;maxRectw = 135;maxRectr = 400;
       summin = 35;
       minArh1 = 25;minArw1 = 155;
       minArh2 = 25;maxArw2 = 145;maxArh2 = 40;
       broff = 20;
       minArh3 = 60;
       minRectch = 45;
       minLinew = 25;minLineh = 25;minLinex = 250;
       birthyoff1 = 154;valiyoff1 = 238;
       birthyoff2 = 134;valiyoff2 = 217;idyoff2 = 380;
    }
    // TODO 修改点：vector<Rect> lines由参数改成局部变量。
    // lines收集所有识别到的字符行，提供给rectSelect进行有效字符行筛选。
    vector<Rect> lines;
    int flag = 0;
   // 提取所有字符轮廓
    std::vector<std::vector<cv::Point> > points1;
    std::vector<cv::Rect> rects1;

    //cv::Ptr<cv::MSER> ptrMSER1 = cv::MSER::create(5,35,210,0.6);
    ptrMSER1->detectRegions(gray, points1, rects1);

#ifdef TDR_TRACE
if(isDebugShow())
{
cv::Mat showmat=gray.clone();
for(int i=0;i < rects1.size();i++)
{
  rectangle(showmat, rects1[i], Scalar(0), 1);
}
imshow("mser", showmat);
//waitKey(0);
}

#endif


    Mat test_mask1 = Mat::zeros(gray.rows,gray.cols,CV_8UC1);

    vector<Rect> charRects1;
    for(int i=0;i < rects1.size();i++)
    {
      Rect brect = rects1[i];
      int width = brect.width;
      int height = brect.height;
      if(camera == 0){
	      if (float(height)/float(width) < 4 && float(height)/float(width) >0.25&&height < 25&&height>3&&!((brect.x+brect.width)>(gray.cols-10)))
	      {
		charRects1.push_back(brect);
	      }
      }
      else
      {
              if (float(height)/float(width) < 4 && float(height)/float(width) >0.25&&height < 25&&height>3&&!((brect.x+brect.width)>(gray.cols-10))&&!((brect.y+brect.height)>(gray.rows-15)))
	      {
		charRects1.push_back(brect);
	      }
      }
    }

    for (int i=0;i < charRects1.size();i++) {
      rectangle(test_mask1, charRects1[i], Scalar(255), -1);
    }
#ifdef TDR_TRACE  
//if(isDebugShow()) imshow("test_mask1",test_mask1);
#endif
      // TODO 修改点1：合并两次闭操作为一次，参数设置相同，验证结果相同
      Mat linemask1;
      Mat element = getStructuringElement(MORPH_RECT, Size(27, 2));
      morphologyEx(test_mask1, linemask1, CV_MOP_CLOSE, element, Point(-1, -1), 1, BORDER_CONSTANT, Scalar(0));

#ifdef TDR_TRACE
//if(isDebugShow()) imshow("linemask1",linemask1);
 //     waitKey(0);
#endif
     vector<vector<Point> > contours_mask;
     findContours(linemask1, contours_mask, 0,1);

     vector<vector<Point> > contours_poly( contours_mask.size() );
  // 根据可能出现的异常情况，来划分识别分支
     for( size_t i = 0; i < contours_mask.size(); i++ ) {
      approxPolyDP( Mat(contours_mask[i]), contours_poly[i], 0, true );
      Rect appRect = boundingRect( Mat(contours_poly[i]) );
      if(appRect.y > (newy + newyoff))
      {
        //float rectarea = appRect.width * appRect.height;
        //float scalem = contourArea(contours_poly[i])/rectarea;

        vector<Rect> rect_cand;
      // 小标题和有效数据粘连的情况，先整体摘出此行，按照有效信息宽度校长的特征，逐行扫描高灰度值占比，
      // 满足有效字符行特征的截取出来，最后算出其位置和边框
      // frongt2/884.png
        if(appRect.height > 35&&appRect.height<maxRecth &&appRect.width < maxRectw&&(appRect.x + appRect.width)< maxRectr)    //35,55,130,220
        {
                 ////cout<<"111111111111"<<endl;
                 Rect rect_tmp;
                 vector<int> proj;
		 Mat cont = Mat::zeros(linemask1.rows,linemask1.cols,CV_8UC1);
		 drawContours(cont, contours_mask, i, Scalar(255), CV_FILLED);
                 ////////////imshow("cont", cont);
		// TODO 修改点：这步没有意义
        //element = getStructuringElement(MORPH_RECT, Size(1, 3));
        //morphologyEx(cont, cont, CV_MOP_DILATE,
        //             element);  //,Point(-1,-1),1,BORDER_CONSTANT, Scalar(0));
        int startc = 0, endc = 0;
        int step = cont.step[0];

        // TODO修改点1：截出的二值图，不需要全图扫描，因预知有效区，按有效区扫描即可
        // 先按有效区预留一段容错区
        int row_start = appRect.y - 10;
        row_start = max(row_start, newy + newyoff);
        int offset = step * row_start;  // 0;
        for (int i = row_start; i < cont.rows; i++) {
          int sum = 0;
          for (int j = 0; j < cont.cols; j++) {
            if (cont.data[offset + j] > 128) sum++;
          }
          offset += step;

          if (sum > summin && i > row_start &&
              proj[i - row_start - 1] <= summin) {
            startc = i;
          } else if (sum <= summin && i > row_start &&
                     proj[i - row_start - 1] > summin) {
            endc = i;
          }
          proj.push_back(sum);
          if ((endc - startc) > 5) {
            rect_tmp.y = startc;
            rect_tmp.height = endc - startc;
            rect_tmp.x = appRect.x;
            rect_tmp.width = appRect.width;
            startc = i;
            rect_cand.push_back(rect_tmp);
          }
        }
      } else if (appRect.height > minArh1 && appRect.width > minArw1) {
        //cout << "22222222222" << endl;
        // 此分支按照参数配置应该是仅针对有效日期的异常保护
        vector<int> proj;
        Mat cont = Mat::zeros(linemask1.rows, linemask1.cols, CV_8UC1);
        drawContours(cont, contours_mask, i, Scalar(255), CV_FILLED);
		// TODO 修改点：这步没有意义
        //element = getStructuringElement(MORPH_RECT, Size(1, 3));
        //morphologyEx(cont, cont, CV_MOP_DILATE,
        //             element);  //,Point(-1,-1),1,BORDER_CONSTANT, Scalar(0));
        int startc = 0, endc = 0;
        int step = cont.step[0];

        // TODO修改点1：截出的二值图，不需要全图扫描，因预知有效区，按有效区扫描即可
        // 先按有效区预留一段容错区
        int row_start = appRect.y - 10;
        row_start = max(row_start, newy + newyoff);
        int offset = step * row_start;  // 0;
        for (int i = row_start; i < cont.rows; i++) {
          int sum = 0;
          for (int j = 0; j < cont.cols; j++) {
            if (cont.data[offset + j] > 128) sum++;
          }
          offset += step;

          if (sum > 150 && i > row_start && proj[i - row_start - 1] <= 150) {
            startc = i;
          } else if (sum <= 150 && i > row_start &&
                     proj[i - row_start - 1] > 150) {
              endc = i;
           }
           proj.push_back(sum);
           if(endc > startc)
           {
              ////////////cout<<startc<<" "<<endc<<endl;
              break;
           }
         }
         appRect.y = startc;
         appRect.height = endc-startc;
        }
        else if(appRect.height > minArh2&& appRect.width <maxArw2 && appRect.height <= maxArh2)
        {
        // TODO
        // 这个分支目前从测试结果看像是图片没有摆正的情况下，识别轮廓过宽，默认前面才是有效数据，所以按照前面数据高度取范围
        // 目前的测试情况看到这个分支的校正数据较杂，且大多数不是后续需要选取的有效行。所以其进行了简单位置处理？
           ////cout<<"3333333333"<<endl;
           int br = appRect.br().y;
           appRect.y = br - broff;   //16
           appRect.height = broff;
        }
        if(appRect.height > minArh3)
	{
		// TODO 去掉特殊无效块轮廓，没有找到对应测试图
           continue;
        }
        if(rect_cand.size()==0)
        {
          appRect.x*=scale_800;
          appRect.y*=scale_800;
          appRect.width*=scale_800;
          appRect.height*=scale_800;
          lines.push_back(appRect);
        }
        else
        {
          for(int p=0;p<rect_cand.size();p++)
          {
            rect_cand[p].x*=scale_800;
            rect_cand[p].y*=scale_800;
            rect_cand[p].width*=scale_800;
            rect_cand[p].height*=scale_800;

            if(rect_cand[p].height > minRectch)
            {
		    Rect hrect1,hrect2;
		    hrect1.x = rect_cand[p].x;//appRect.x*scale_800;
		    hrect1.y = rect_cand[p].y;//appRect.y*scale_800;
		    hrect1.height = rect_cand[p].height/2;
		    hrect1.width = rect_cand[p].width;

		    hrect2.width = hrect1.width;
		    hrect2.height = hrect1.height -10;
		    hrect2.x = hrect1.x;
		    hrect2.y = hrect1.y + hrect1.height + 10;
		    lines.push_back(hrect1);
		    lines.push_back(hrect2);
            }

            else lines.push_back(rect_cand[p]);
          }
        }
      }
   }
   //cout<<"lines size is ............."<<lines.size()<<" "<<lines[11].x<<" "<<lines[11].y<<endl;
    flag = 0;
    Rect rect_name, rect_birthday, rect_valid_from_to, rect_id;
    int yoffset = 17, idxname = -1, idxbirth = -1, idxvalid = -1, idid = -1;  //15
    // 按照Y轴排序，再根据固定矩形框大概位置定位"名称字符行"。
    sort(lines.begin(), lines.end(), comp_y);
    for (int i=0; i< lines.size();i++) {
     if (lines[i].width>minLinew&&lines[i].height>minLineh&&lines[i].x > minLinex) {
      rect_name = lines[i];
      idxname = i;
      break;
      }
    }

    int finded = 0;
    int y = rect_name.y;
    // 后续都是通过寻找与名称字符行等相对位置，来定位寻找有效字符行信息的
    //////////cout<<"cardclass is "<<cardClass<<endl;
    if(cardClass == 2)
    {
	    for (int i=1; i< lines.size();i++) {
	      if (abs(lines[i].y-y-birthyoff1)<yoffset && lines[i].width > 100) {
		rect_birthday = lines[i]; //birthday: 1
		idxbirth = i;
		//finded++;
	      }
	      if (abs(lines[i].y-y-valiyoff1)<yoffset && lines[i].width > 100) {
		rect_valid_from_to = lines[i]; //valid_from_to: 3
		idxvalid = i;
		//finded++;
	      }
	    }
           if(idxbirth!=-1&&idxvalid!=-1)
           {
             finded = 2;
           }
	   else
           {
             finded = 0;
           }
          if(finded < 2)
	  {
             //lines.clear();
             vector<Rect>().swap(lines);
	     flag = -1;
	  }
          ////cout<<"flag is ++++++++++++"<<finded<<" "<<idxname<<" "<<idxbirth<<" "<<idxvalid<<endl;
    }
    else
    {
	    //finded = 0;idxbirth = -1;idxvalid = -1;
            //////////cout<<"TW card "<<finded<<" "<<idxname<<endl;
	    for (int i=1; i< lines.size();i++) {
	      if (abs(lines[i].y-y-birthyoff2)<yoffset && lines[i].width > 100) {
		rect_birthday = lines[i]; //birthday: 1
		idxbirth = i;
		//finded++;
	      }
	      if (abs(lines[i].y-y-valiyoff2)<yoffset && lines[i].width > 100) {
		rect_valid_from_to = lines[i]; //valid_from_to: 3
		idxvalid = i;
		//finded++;
	      }
              if(abs(lines[i].y-y-idyoff2)<yoffset && lines[i].width > 100)
              {
                 rect_id = lines[i]; //id: 4
                 idid = i;
                 //finded++;
              }
	    }
           if(idxbirth!=-1&&idxvalid!=-1&&idid!=-1)
           {
             finded = 3;
           }
	   else
           {
             finded = 0;
           }
           if(finded < 3)
	  {
             //lines.clear();
             vector<Rect>().swap(lines);
	     flag = -1;
	  }
    }
	  //////////cout<<idxname<<" "<<idxbirth<<" "<<idxvalid<<" "<<idid<<endl;
//	  if(finded < 2)
//	  {
//             lines.clear();
//	     flag = -1;
//	  }
          ////////////cout<<"flag inside is "<<flag<<" "<<finded<<endl;
	  if(0==flag){
        // TODO
        // :有识别不充分对齐的作用，不能去掉。此时不能判断rect_xx.c的位置。不确定是否是设计意图。
	    int minlinex = min(min(lines[idxname].x, lines[idxbirth].x), lines[idxvalid].x);
	    int namewidthoff = lines[idxname].x - minlinex;
	    int birthwidthoff = lines[idxbirth].x - minlinex;
	    int validwidthoff = lines[idxvalid].x - minlinex;
	    lines[idxname].x = minlinex;
	    lines[idxbirth].x = minlinex;
	    lines[idxvalid].x = minlinex;
	    lines[idxname].width = lines[idxname].width + namewidthoff;
	    lines[idxbirth].width = lines[idxbirth].width + birthwidthoff;
	    lines[idxvalid].width = lines[idxvalid].width + validwidthoff;

            if(cardClass == 1)
            {
              minlinex = min(minlinex, lines[idid].x);
              int idwidthoff = lines[idid].x - minlinex;
              lines[idid].x = minlinex;
              lines[idid].width = lines[idid].width + idwidthoff;
            }

	    flag = rectSelect(src, lines, linesSelect, cardClass, camera);
            //////////cout<<"flag after is "<<flag<<endl;
            flag=0;
	}
        return flag;
}

/*************************************************
Function:       lineSelect_back
Description:
获取卡片背面有效字符行列表。非机读区默认是有效字符行，机读区需要进行宽度判断。
机读区添加不完整行（如局部过曝引起、白线引起）异常容错机制。

Input:          src: 卡片信息彩色图像。
                gray: src缩小一半的灰度图。
                lines: 存储返回的定位到的有效字符行信息。
                ptrMSER:固定参数的cv::MSER实例句柄，有外层调用函数负责设置。
                scale: src与gray的比例关系
                camera: 新旧摄像头标识。1是旧摄像头。

Return:         成功返回0， 失败返回-1。
*************************************************/
int lineSelect_back(Mat& src, Mat& gray, vector<Rect>& lines, cv::Ptr<cv::MSER>& ptrMSER, int scale, int camera) 
{
  double start, end;
  start = tdr_get_current_time();

  int minLinewh = 365;int minLinew = 730;
  if(camera == 1)
  {
    minLinewh = 415;minLinew = 830;
  }
  // TODO 参数验证
  int char_dist = 60;
  int need_rotation = 0;
  // TODO 是否像卡片正面那样小图验证是否需要翻转会更好？
  // 提取所有字符轮廓
  int height = gray.rows;
  std::vector<std::vector<cv::Point> > points;
  std::vector<cv::Rect> rects;
  ptrMSER->detectRegions(gray,points,rects);


  Mat test_mask = Mat::zeros(gray.rows,gray.cols,CV_8UC1);

  vector<cv::Rect> charRects;
  for(int i=0;i < rects.size();i++)
  {
    Rect brect = rects[i];
    int widthc = brect.width;
    int heightc = brect.height;
    if (float(heightc)/float(widthc) < 4 && float(heightc)/float(widthc) >0.25 &&heightc>5&&!(brect.x<5)&&!(brect.y < 5)&&!((brect.x+brect.width)>(gray.cols-6)))//-10, height < 20&&
    {
      charRects.push_back(brect);
    }
  }

  for (int i=0;i < charRects.size();i++) {
    rectangle(test_mask, charRects[i], Scalar(255), -1);
  }
//  ////////////imshow("test_mask",test_mask);
  // 提取所有字符行轮廓
  Mat linemask;
  //Mat element = getStructuringElement(MORPH_RECT, Size(27, 1) ); www
  //Mat element = getStructuringElement(MORPH_RECT, Size(21, 1) );
  Mat element = getStructuringElement(MORPH_RECT, Size(15, 1) );
  morphologyEx(test_mask, linemask, CV_MOP_CLOSE, element,Point(-1,-1),1,BORDER_CONSTANT, Scalar(255));

  vector<vector<Point> > contours_mask;
  vector<RotatedRect> 	contoursrRect;
  findContours(linemask, contours_mask, 0, 1);
  // imshow("linemask", linemask);
  // imwrite("lm.png", linemask);
  //  waitKey(0);

  for (size_t i = 0; i < contours_mask.size(); i++) {
    // Rect appRect = boundingRect(Mat(contours_mask[i]));
    RotatedRect apprRect = minAreaRect(contours_mask[i]);
    contoursrRect.push_back(apprRect);
  }

  int crsize = contoursrRect.size();
  if(crsize<1) return -1;
  // 从验证图来看应该是按照轮廓长度大小排序，并且去掉无效矩形框
  sort(contoursrRect.begin(),contoursrRect.end(),comp);
  float roi_angle = contoursrRect[0].angle;
  int cnty = contoursrRect[0].center.y;
  if(roi_angle < -45) roi_angle += 90;
  //printf("roi_angle=%f\n", roi_angle);


  // TODO
  // 修改点1：因为在卡片定位时已经有图片校正的操作，所以此处根据需求来判断是否校正
  if (fabs(roi_angle) > ROI_ANGLE_VALUE) {
    //printf("---roi_angle=%f, need imgRotate--\n", roi_angle);
    imgRotate(linemask, roi_angle, 1.0);
    need_rotation |= 0x01;
// imgRotate(src, roi_angle, 1.0);
#ifdef SUPPORT_TEST_CTL
    set_rotate_status();
#endif
  }
  // 卡片背面可用有效字符行的高度占比来判断，卡片是否倒了。倒了需要在次校正
  if (cnty < 0.6 * height) {
    flip(linemask, linemask, -1);
    need_rotation |= 0x02;
    // flip(src, src, -1);
  }

  vector<vector<Point> >().swap(contours_mask);
  findContours(linemask, contours_mask, 0, 1);
  vector<Rect> longRects;
  vector<Rect> indeterminacy_rect;
  // 灰度图的1.2倍是原图的0.6倍，与上面倒转的高度判断一致
  int tmp_len = 1.2 * height;
  for (int i = 0; i < contours_mask.size(); i++) {
    Rect appRect = boundingRect(Mat(contours_mask[i]));
    appRect.x *= scale;
    appRect.y *= scale;
    appRect.width *= scale;
    appRect.height *= scale;
    // 非机读区的字符行，默认为有效行
    if (appRect.y < tmp_len) {
      lines.push_back(appRect);
    } else {
      if (appRect.width > minLinew) {
        longRects.push_back(appRect);
      } else {
        if (appRect.height < char_dist) indeterminacy_rect.push_back(appRect);
      }
    }
  }
  ////////////cout<<"longRects size is "<<longRects.size()<<endl;
  if(longRects.size()<2) return -1;
  // TODO 修改点2：机读区有效数据，容错处理。
  if(longRects.size() < 3){
    // 灰度图的1.6倍是原图的0.8倍.使用中不包含最后一行y坐标，不合理
    // TODO 此次改成灰度的1.8倍，原图的0.9倍，将3行的y坐标都包含进去
    tmp_len = 1.8 * height;
	  int numlong = 0;
	  for(int i=0;i<longRects.size();i++)
	  {
	    if(longRects[i].y < tmp_len)
	      numlong ++;
	  }
          ////////////cout<<"numlong is "<<numlong<<endl;
          if(numlong == 2)
          {
#if 0              
            // 旧的容错方案理实现不合理,不考虑误识别无效块
            vector<Rect> thirdlines;
            // 灰度图的0.8倍是原图的0.4倍。
            // back2/1915.png
            // 此分支的意图是解决机读区不完整行的问题？那为什么要提高度？
            tmp_len = 0.8 * height;
            for(int i=0;i<contours_mask.size();i++)
            {
                   Rect appRect = boundingRect( Mat(contours_mask[i]) );
                   if(appRect.y > tmp_len)
		   {
     		     appRect.x*=scale;
     		     appRect.y*=scale;
     		     appRect.width*=scale;
     	 	     appRect.height*=scale;
                     thirdlines.push_back(appRect);
                   }
            }
			if(thirdlines.size() < 1) return -1;
            sort(thirdlines.begin(), thirdlines.end(), comp_x);
            int tsize = thirdlines.size();
            Rect thirdline;
            thirdline.x = thirdlines[0].x;
            thirdline.y = thirdlines[0].y;
            thirdline.width = thirdlines[tsize-1].br().x - thirdline.x;
            thirdline.height = thirdlines[0].height;
            if(thirdline.width > minLinew)
              longRects.push_back(thirdline);
 
#endif

      int ret = process_indeterminacy_rect_back(longRects, indeterminacy_rect,
                                                char_dist, minLinew);
      if (ret != 0) return ret;
    }
  }

  if(longRects.size()<3) return -1;

  // 对齐补充功能在存在不完整行的时候效果明显。
  // 限定机读区数据有效矩形框的起点x坐标<=100。
  int longStart = 100;
  for(int i=0;i<longRects.size();i++)
  {
    if(longRects[i].x < longStart)
    {
       longStart = longRects[i].x;
    }
  }

  int max_width = 0;
  // 限定机读区数据有效矩形框左对齐
  for(int i=0;i<longRects.size();i++)
  {
    int buff = longRects[i].x - longStart;
    longRects[i].width += buff;
    longRects[i].x = longStart;
    // TODO 这个什么依据？？？
    if(longRects[i].height > 50)
    {
       longRects[i].height = 30;
    }
    // TODO 之前只考虑机读区的左对齐，没有考虑右对齐。行尾缺失会有问题
    if(longRects[i].width > max_width)
    {
       max_width = longRects[i].width;
    }
    //lines.push_back(longRects[i]);
  }  

  // 用上面左对齐后的max_width进行右对齐，不会有越界问题。
  for(int i=0;i<longRects.size();i++)
  {
    if(longRects[i].width < max_width)
    {
        longRects[i].width = max_width;
    }
    lines.push_back(longRects[i]);
  }

  // 原图 成功了才翻转
  if ((need_rotation & 0x01) == 0x01) imgRotate(src, roi_angle, 1.0);
  if ((need_rotation & 0x02) == 0x02) flip(src, src, -1);

  end = tdr_get_current_time();
  LOGD("get_valid_lines_back cost time: %.3f ms", end - start);
#ifdef SUPPORT_TEST_CTL
  append_test_info_item("---卡片后面有效字符行筛选: ", (int)(end - start));
#endif
  return 0;
}

/*************************************************
Function:       detectLettersRect_new3
Description:    定位卡片正面有效字符行位置。并提供校正后的图。

Calls: check_and_rotated_card_front：判定卡片是否摆正，未摆正重新校正
                get_valid_lines_front:获取有效字符行列表

Input:          src: 卡片信息彩色图像。
                rectFace: 人脸信息在卡片图上的位置。
                linesSelect: 存储返回的定位到的有效字符行信息。
                cardClass:卡片类型标识。1=FROM_TW, 2=TO_HK。
                camera: 新旧摄像头标识。1是旧摄像头。

Return:         成功返回0， 失败返回-1。
*************************************************/
int detectLettersRect_new3(Mat& src, Rect rectFace, vector<Rect>& linesSelect, int cardClass, int camera) 
{
  int charheight = 25;
  int closelinedis = 40;
  int fminw = 60;
  int fminh = 15;
  int mserFirstMax = 220;
  float mserFirstScale = 0.37;
  int mserSecondMax = 210;
  if(camera == 1)
  {
    charheight = 28;
    closelinedis = 50;
    fminw = 65;fminh = 17;
    mserFirstMax = 280;
    mserFirstScale = 0.32;
    mserSecondMax = 280;
  }

  double start, end;
  double sum = 0;
  start = tdr_get_current_time();

  int scale_800, width, height;
  Mat img, gray;
  // TODO 修改点1:调整执行顺序，先缩成小图，再在小图上覆盖人脸部分，可以提速
  scale_800 = 2;
  width = src.cols / scale_800;
  height = src.rows / scale_800;
  resize(src, img, Size(width, height),
         cv::INTER_NEAREST);  // INTER_NEAREST INTER_LINEAR
  if (img.channels() > 1) {
    cvtColor(img, gray, CV_BGR2GRAY);
  } else {
    gray = img;
  }

  if (rectFace.width > 0 && rectFace.height > 0) {
    Rect headRect;
    int x1 = rectFace.x - 50;
    int x2 = rectFace.x + rectFace.width + 50;
    int y1 = rectFace.y - 80;
    int y2 = rectFace.y + rectFace.height + 90;
    // 映射到缩小后图上坐标， scale_800正好是2，可用移位，避免使用除法
    x1 = (x1 >> 1);
    x2 = (x2 >> 1);
    y1 = (y1 >> 1);
    y2 = (y2 >> 1);
    headRect.x = max(0, x1);
    headRect.y = max(0, y1);
    headRect.width = min(gray.cols - headRect.x, x2 - headRect.x);
    headRect.height = min(gray.rows - headRect.y, y2 - headRect.y);
    // rectangle(gray, headRect, Scalar(255), -1);
    gray(headRect) = Scalar{255};
  }

  // imshow("gray", gray);
  // waitKey(0);
  // printf(" gray = %d %d\n", gray.cols, gray.rows);

 
  // 获取一小部分含字符行的图片，用来找其轮廓旋转矩，查看当前图是否摆正，未摆正需要仿射变换校正。
  // TODO 修改点1：先取感兴趣空间，再深拷贝，提速。
  Rect detect_roi_rect(0, 0, gray.cols * 0.65, gray.rows * 0.3);
  Mat grayf = gray(detect_roi_rect);
  Mat fgray = grayf.clone();
  //////////imshow("fgray",fgray);
  cv::Ptr<cv::MSER> ptrMSERf = cv::MSER::create(5,25,220,0.7);
  std::vector<std::vector<cv::Point> > pointsf;
  std::vector<cv::Rect> rectsf;

    //cv::Ptr<cv::MSER> ptrMSER1 = cv::MSER::create(5,35,210,0.6);
  ptrMSERf->detectRegions(fgray,pointsf,rectsf);


  Mat test_maskf = Mat::zeros(fgray.rows,fgray.cols,CV_8UC1);

  // 画出字符轮廓
  vector<Rect> charRectsf;
  for(int i=0;i < rectsf.size();i++)
  {
      Rect brect = rectsf[i];
      //int width = brect.width;
      int height = brect.height;
      //if(1)
      if (height < charheight&&height>3&&!(brect.x<25)) //&& (!(height<11&&brect.y > ybegin1)) &&!(brect.x<5) &&!(brect.y < 5) !(brect.x<25) float(height)/float(width) < 4 && float(height)/float(width) >0.25&& &&!((brect.x+brect.width)>(gray.cols-10))
      {
        charRectsf.push_back(brect);
      }
  }

    for (int i=0;i < charRectsf.size();i++) {
      rectangle(test_maskf, charRectsf[i], Scalar(255), -1);
  }

  // 将单字符轮廓连成字符行
  // TODO:修改点2：合并两次闭操作为一次，参数设置相同，验证结果相同
  Mat firstlinemask;
  Mat element = getStructuringElement(MORPH_RECT, Size(closelinedis, 2));
  morphologyEx(test_maskf, firstlinemask, CV_MOP_CLOSE, element, Point(-1, -1),
               1, BORDER_CONSTANT, Scalar(0));  // 0628

//    //imshow("test_maskf",test_maskf);
imshow("firstlinemask",firstlinemask);
waitKey(0);
  // 取卡片类型字符行轮廓，获取其旋转矩，用来确认是否需要仿射变换校正
  vector<RotatedRect> firstlines;
  vector<vector<Point> > contours_firstline;
  findContours(firstlinemask, contours_firstline, 0,1);
  vector<vector<Point> > contours_polyline( contours_firstline.size() );
  for( size_t i = 0; i < contours_firstline.size(); i++ )
  {
      approxPolyDP(Mat(contours_firstline[i]), contours_polyline[i], 0, true);
      RotatedRect frrect = minAreaRect(contours_polyline[i]);
      int rwidth = max(frrect.size.width, frrect.size.height);
      int rheight = min(frrect.size.width, frrect.size.height);
      if(rwidth > fminw&&rheight>fminh)
      {
        firstlines.push_back(frrect);
      }
  }
  if(firstlines.size()<1) return -1;
  sort(firstlines.begin(),firstlines.end(),comp_rotcenter);
  RotatedRect box = firstlines[0];
  Point2f vertex[4];
  box.points(vertex);
  int eflag = 0;
//  for(int i=0;i<4;i++)
//  {
 //   line(firstlinemask, vertex[i], vertex[(i+1)%4], Scalar(255),2,CV_AA);
//  }
  if(camera == 0){
	  for(int i=0;i<4;i++)
	  {
	    if(vertex[i].x > firstlinemask.cols -1 ||vertex[i].y > firstlinemask.rows -1)
	    eflag = -1;
	  }
  }
  else
  {
	   for(int i=0;i<4;i++)
	  {
	    if(vertex[i].x < 0 || vertex[i].y < 0 || vertex[i].x > firstlinemask.cols -1 ||vertex[i].y > firstlinemask.rows -1)
	    eflag = -1;
	  }
  }


  ////////////waitkey(0);
  float roi_angle = firstlines[0].angle;
  if(roi_angle < -45) roi_angle += 90;
  Point line1c = firstlines[0].center;
  Point newline1c = pointRot(line1c,firstlinemask.rows,firstlinemask.cols,roi_angle);

//  imgRotate(test_mask1, roi_angle, 1.0);
// TODO 疑问： 为什么只调整 旧摄像头？
  if (fabs(roi_angle) > ROI_ANGLE_VALUE) {
  	//if (camera == 1) imgRotate(test_maskf, roi_angle, 1.0);
  	imgRotate(test_maskf, roi_angle, 1.0);
  }
  Rect linerect;
  int linewidth = max(firstlines[0].size.width, firstlines[0].size.height);
  int lineheight = min(firstlines[0].size.width, firstlines[0].size.height);
  if(camera == 1)
  {
      if(lineheight > 60) eflag = -1;
  }
  if(-1 == eflag) newline1c.y -=20;
    ////cout<<"++++++++="<<newline1c.y<<endl;
if(0==eflag){
  linerect.x = max(0,newline1c.x - linewidth/2);
  linerect.y = max(0,newline1c.y - lineheight/2);
  linerect.width = linewidth;
  linerect.height = lineheight;
  Mat lineimg = test_maskf(linerect);
  vector<vector<Point> > contours_linechr;
  findContours(lineimg, contours_linechr, 0,1);
//  //////////cout<<"contours_linechr size is "<<contours_linechr.size()<<endl;
  int charnum = 0;
  for(int i=0;i<contours_linechr.size();i++)
  {
     Rect lineRect = boundingRect( Mat(contours_linechr[i]) );
     if(lineRect.height>10) charnum ++;
  }
    // TODO预设置？依据？
  if(linewidth > 150) charnum = 5;

  if(charnum < 3) return -1;
// TODO
  // 修改点4:因卡片定位时已经校正过图片，此处仅对卡片定位误差较大的情况进行处理。
    if (fabs(roi_angle) > ROI_ANGLE_VALUE) {
    	imgRotate(src, roi_angle, 1.0);
		  imgRotate(gray, roi_angle, 1.0);
      #ifdef SUPPORT_TEST_CTL
      set_rotate_status();
      #endif       
    }
  }

  blur(gray, gray, cv::Size(3, 1));

  cv::Ptr<cv::MSER> ptrMSER = cv::MSER::create(5,35,mserFirstMax,mserFirstScale);
  int flag = lineSelect1(src, gray, linesSelect, ptrMSER, scale_800, newline1c.y, cardClass, camera);

  if (-1 == flag) 
  {
    vector<Rect>().swap(linesSelect);
    //cv::Ptr<cv::MSER> ptrMSER1 = cv::MSER::create(4,35,mserSecondMax,0.6);
    cv::Ptr<cv::MSER> ptrMSER1 = cv::MSER::create(5,35,mserSecondMax,0.6);
    flag = lineSelect1(src, gray, linesSelect, ptrMSER1, scale_800, newline1c.y, cardClass, camera);
  }



  end = tdr_get_current_time();
  LOGD("detectLettersRect_new3 cost time: %.3f ms", end - start);
#ifdef SUPPORT_TEST_CTL
  append_test_info_item("--卡片前面字符行定位: ", (int)(end - start));
#endif
  return flag;
}

/*************************************************
Function:       detectLettersRect_back
Description:    定位卡片背面有效字符行位置。并提供校正后的图。

Calls:          lineSelect_back:获取卡片背面有效字符行列表。

Input:          src: 卡片信息彩色图像。
                lines: 存储返回的定位到的有效字符行信息。
                camera: 新旧摄像头标识。1是旧摄像头。

Return:         成功返回0， 失败返回-1。
*************************************************/
int detectLettersRect_back(Mat& src, vector<Rect>& lines,
                           int camera) {
  double start, end;
  double sum = 0;
  start = tdr_get_current_time();

  int scale = 2;
  Mat img,gray;
  int width = src.cols/scale;
  int height = src.rows/scale;

  //////////////cout<<"size is "<<width<<" "<<height<<endl;

  resize(src, img, Size(width,height),cv::INTER_NEAREST);
  if(img.channels()>1)
  {
    cvtColor(img, gray, CV_BGR2GRAY);
  }
  else
  {
    gray = img;
  }

  blur(gray, gray, cv::Size(3, 1));
//printf("============>\n");

  cv::Ptr<cv::MSER> ptrMSER = cv::MSER::create(5,20,220,0.37);      //5,35,180,0.8   5,2,220,1.0
  //cv::Ptr<cv::MSER> ptrMSER = cv::MSER::create(5,8,100,0.5);      //5,35,180,0.8   5,2,220,1.0
  int flag = lineSelect_back(src, gray, lines, ptrMSER, scale, camera);
  if (flag < 0) {
    // 第一个执行分支操作失败，再准备第二个分支的数据
    cv::Ptr<cv::MSER> ptrMSER1 = cv::MSER::create(5, 20, 220, 0.9);
    vector<Rect>().swap(lines);
    flag = lineSelect_back(src, gray, lines, ptrMSER1, scale, camera);
  }

  end = tdr_get_current_time();
  LOGD("detectLettersRect_back cost : %.3f ms", end - start);
  #ifdef SUPPORT_TEST_CTL
  append_test_info_item("--卡片后面字符行定位: ", (int)(end - start));
  #endif

  if (flag < 0)
    return -1;
  else
    return 0;

  return -1;
}


/*************************************************
Function:       process_indeterminacy_rect_back
Description:
  卡片背面异常情况的容错机制。仅考虑机读区3行信息中有2行已定位缺失一行的情况。
  先判断是否是其中两行粘连在一起的原因，是则拆开。若不是，
  再判断是否是其中某行识别轮廓不准导致部分缺失的原因。是则把断行连起来，
  做作简单的判断，看是否满足条件。

Input:          valid_rects: 已识别到的机读区轮廓框。
        容错处理成功后，改向返回完整的机读区轮廓框。
                indeterminacy_rect: 已识别到的机读区异常框。
                char_dist:
机读区单行字符高度极限值，用来区分行相对位置，即异常行的有效性。
                min_Line_width:用来判断断行连接后是否的行宽需求。

Return:         成功返回0， 失败返回-1。
*************************************************/
int process_indeterminacy_rect_back(vector<Rect>& valid_rects,
                                    vector<Rect>& indeterminacy_rect,
                                    int char_dist, int min_Line_width) {
  // 仅考虑丢一行的情况
  int h_1 = valid_rects[0].height;
  int h_2 = valid_rects[1].height;
  int y_1 = valid_rects[0].y;
  int y_2 = valid_rects[1].y;
  int indeterminacy_cnt = indeterminacy_rect.size();

  // printf("y_1=%d, y_2=%d, indeterminacy_cnt=%d \n", y_1, y_2,
  //       indeterminacy_cnt);
  // printf("h_1=%d, h_2=%d \n", h_1, h_2);
  vector<Rect> thirdlines;
  // 看是否是某行由两行粘连得到
  // 也可以用h_1/h_2来判断是否是相近字符行粘连
  if (h_1 > char_dist && h_2 <= char_dist) {
    // back3/2957.png
    //printf("后两行粘连 \n");
    int tmp_h = (valid_rects[0].height + 1) >> 1;
    valid_rects[0].height = tmp_h;

    thirdlines.push_back(valid_rects[0]);
    thirdlines[0].y += tmp_h;

  } else if (h_2 > char_dist && h_1 <= char_dist) {
    // back3/1937_1.png
    //printf("前两行粘连 \n");
    int tmp_h = (valid_rects[1].height + 1) >> 1;
    valid_rects[1].height = tmp_h;

    thirdlines.push_back(valid_rects[1]);
    thirdlines[0].y += tmp_h;
  } else if (h_1 <= char_dist && h_2 <= char_dist) {
    //printf("局部缺失 \n");
    // 考虑因为局部数据缺失而丢行
    if (y_1 > y_2) {
      int tmp = y_1;
      y_1 = y_2;
      y_2 = tmp;
    }

    if ((y_2 - y_1) < char_dist) {
      // TODO 丢失行在两边
      int valid_idx = 0;
      int side_status = 0;
      int dist;
      // 先确定是哪边
      for (; valid_idx < indeterminacy_cnt; valid_idx++) {
        dist = y_1 - indeterminacy_rect[valid_idx].y;
        if (dist > 0 && dist < char_dist) {
          side_status = 1;
          // 批图验证。back2/1915_2.png，因颠倒机读区顺序，最后识别失败
          //printf("首行局部缺失 \n");
          break;
        } else {  /// back2/1915.png
          dist = indeterminacy_rect[valid_idx].y - y_2;
          if (dist > 0 && dist < char_dist) {
            side_status = 2;
            //printf("尾行局部缺失 \n");
            break;
          }
        }
      }
      if (valid_idx == indeterminacy_cnt) return -1;
      thirdlines.push_back(indeterminacy_rect[valid_idx]);
      //
      for (valid_idx = valid_idx + 1; valid_idx < indeterminacy_cnt;
           valid_idx++) {
        if (1 == side_status) {
          dist = y_1 - indeterminacy_rect[valid_idx].y;
        } else {
          dist = indeterminacy_rect[valid_idx].y - y_2;
        }

        if (dist > 0 && dist < char_dist) {
          thirdlines.push_back(indeterminacy_rect[valid_idx]);
        } else {  // 确定边后，仍有不确定数据，直接错误退出
          return -1;
        }
      }
    } else {
      // 批图验证。back2/1915_1.png，因颠倒机读区顺序，最后识别失败
      //printf("中间行局部缺失 \n");
      for (int i = 0; i < indeterminacy_cnt; i++) {
        if (indeterminacy_rect[i].y < y_2 && indeterminacy_rect[i].y > y_1) {
          thirdlines.push_back(indeterminacy_rect[i]);
        }
      }
    }
  } else
    return -1;

  if (thirdlines.size() < 1) return -1;
  sort(thirdlines.begin(), thirdlines.end(), comp_x);
  int tsize = thirdlines.size();
  //printf("tsize =%d \n", tsize);
  Rect thirdline;
  thirdline.x = thirdlines[0].x;
  thirdline.width = thirdlines[tsize - 1].br().x - thirdline.x;
  // TODO 局部缺失行可能行首缺失，不能按照标准长度判断，应该给一些误差冗余
  if (thirdline.width > (min_Line_width >> 1)) {
    // TODO 改成选取高度最大值和最低点y值
    //thirdline.height = thirdlines[0].height;
    //thirdline.y = thirdlines[0].y;
    int min_y = 0x7FFFFFFF;
    int max_h = 0;
    for (int k = 0; k <thirdlines.size(); k++) {
      if(thirdlines[k].y < min_y)min_y = thirdlines[k].y;
      if(thirdlines[k].height > max_h)max_h = thirdlines[k].height;
    }
    thirdline.height = max_h;
    thirdline.y = min_y;
    valid_rects.push_back(thirdline);
  }
  return 0;
}




/*************************************************
Function:       detectLettersRect_new3
Description:    定位卡片正面有效字符行位置。并提供校正后的图。

Calls: check_and_rotated_card_front：判定卡片是否摆正，未摆正重新校正
                get_valid_lines_front:获取有效字符行列表

Input:          src: 卡片信息彩色图像。
                rectFace: 人脸信息在卡片图上的位置。
                linesSelect: 存储返回的定位到的有效字符行信息。
                cardClass:卡片类型标识。1=FROM_TW, 2=TO_HK。
                camera: 新旧摄像头标识。1是旧摄像头。

Return:         成功返回0， 失败返回-1。
*************************************************/
int check_and_rotated_card_front(Mat& src, Rect rectFace, vector<Rect>& linesSelect, int cardClass, int camera)
{
  int charheight = 25;
  int closelinedis = 40;
  int fminw = 60;
  int fminh = 15;
  int mserFirstMax = 220;
  float mserFirstScale = 0.37;
  int mserSecondMax = 210;
  if(camera == 1)
  {
    charheight = 28;
    closelinedis = 50;
    fminw = 65;fminh = 17;
    mserFirstMax = 280;
    mserFirstScale = 0.32;
    mserSecondMax = 280;
  }

  double start, end;
  double sum = 0;
  start = tdr_get_current_time();

  int scale_800, width, height;
  Mat img, gray;
  // TODO 修改点1:调整执行顺序，先缩成小图，再在小图上覆盖人脸部分，可以提速
  scale_800 = 2;
  width = src.cols / scale_800;
  height = src.rows / scale_800;
  resize(src, img, Size(width, height),
         cv::INTER_NEAREST);  // INTER_NEAREST INTER_LINEAR
  if (img.channels() > 1) {
    cvtColor(img, gray, CV_BGR2GRAY);
  } else {
    gray = img;
  }

  if (rectFace.width > 0 && rectFace.height > 0) {
    Rect headRect;
    int x1 = rectFace.x - 50;
    int x2 = rectFace.x + rectFace.width + 50;
    int y1 = rectFace.y - 80;
    int y2 = rectFace.y + rectFace.height + 90;
    // 映射到缩小后图上坐标， scale_800正好是2，可用移位，避免使用除法
    x1 = (x1 >> 1);
    x2 = (x2 >> 1);
    y1 = (y1 >> 1);
    y2 = (y2 >> 1);
    headRect.x = max(0, x1);
    headRect.y = max(0, y1);
    headRect.width = min(gray.cols - headRect.x, x2 - headRect.x);
    headRect.height = min(gray.rows - headRect.y, y2 - headRect.y);
    // rectangle(gray, headRect, Scalar(255), -1);
    gray(headRect) = Scalar{255};
  }

  // imshow("gray", gray);
  // waitKey(0);
  // printf(" gray = %d %d\n", gray.cols, gray.rows);


  // 获取一小部分含字符行的图片，用来找其轮廓旋转矩，查看当前图是否摆正，未摆正需要仿射变换校正。
  // TODO 修改点1：先取感兴趣空间，再深拷贝，提速。
  Rect detect_roi_rect(0, 0, gray.cols * 0.65, gray.rows * 0.3);
  Mat grayf = gray(detect_roi_rect);
  //cv::GaussianBlur(grayf,grayf,cv::Size(5,5),5,5);
//imshow("grayf", grayf);

  Mat fgray = grayf.clone();
  //////////imshow("fgray",fgray);

  cv::Ptr<cv::MSER> ptrMSERf = cv::MSER::create(5,25,220,0.7);
  std::vector<std::vector<cv::Point> > pointsf;
  std::vector<cv::Rect> rectsf;

    //cv::Ptr<cv::MSER> ptrMSER1 = cv::MSER::create(5,35,210,0.6);
  ptrMSERf->detectRegions(fgray,pointsf,rectsf);


  Mat test_maskf = Mat::zeros(fgray.rows,fgray.cols,CV_8UC1);

  // 画出字符轮廓
  vector<Rect> charRectsf;
  for(int i=0;i < rectsf.size();i++)
  {
      Rect brect = rectsf[i];
      //int width = brect.width;
      int height = brect.height;
      //if(1)
      if (height < charheight&&height>3&&!(brect.x<25)) 
      {
        charRectsf.push_back(brect);
      }
  }

    for (int i=0;i < charRectsf.size();i++) {
      rectangle(test_maskf, charRectsf[i], Scalar(255), -1);
  }

  // 将单字符轮廓连成字符行
  // TODO:修改点2：合并两次闭操作为一次，参数设置相同，验证结果相同
  Mat firstlinemask;
  Mat element = getStructuringElement(MORPH_RECT, Size(closelinedis, 2));
  morphologyEx(test_maskf, firstlinemask, CV_MOP_CLOSE, element, Point(-1, -1),
               1, BORDER_CONSTANT, Scalar(0));  // 0628

//    //imshow("test_maskf",test_maskf);
 //imshow("firstlinemask",firstlinemask);
//  //waitkey(0);
  // 取卡片类型字符行轮廓，获取其旋转矩，用来确认是否需要仿射变换校正
  vector<RotatedRect> firstlines;
  vector<vector<Point> > contours_firstline;
  findContours(firstlinemask, contours_firstline, 0,1);
  vector<vector<Point> > contours_polyline( contours_firstline.size() );
  for( size_t i = 0; i < contours_firstline.size(); i++ )
  {
      approxPolyDP(Mat(contours_firstline[i]), contours_polyline[i], 0, true);
      RotatedRect frrect = minAreaRect(contours_polyline[i]);
      int rwidth = max(frrect.size.width, frrect.size.height);
      int rheight = min(frrect.size.width, frrect.size.height);
      if(rwidth > fminw&&rheight>fminh)
      {
        firstlines.push_back(frrect);
      }
  }
  if(firstlines.size()<1) return -1;
  sort(firstlines.begin(),firstlines.end(),comp_rotcenter);
  RotatedRect box = firstlines[0];
  Point2f vertex[4];
  box.points(vertex);
  int eflag = 0;


  float roi_angle = firstlines[0].angle;
  if(roi_angle < -45) roi_angle += 90;

  // 修改点4:因卡片定位时已经校正过图片，此处仅对卡片定位误差较大的情况进行处理。
    if (fabs(roi_angle) > ROI_ANGLE_VALUE) {
    	imgRotate(src, roi_angle, 1.0);
    }

  end = tdr_get_current_time();
  LOGD("rotate: %.3f ms", end - start);
  return 0;
}
