#include <opencv2/imgproc/imgproc.hpp>  // Gaussian Blur
#include <opencv2/core/core.hpp>        // Basic OpenCV structures (cv::Mat, Scalar)
#include <opencv2/highgui/highgui.hpp>  // OpenCV window I/O
#include <stdio.h>
#include <string>
#include <vector>
#include <iostream>
#include <omp.h>
#include "common.h"
using namespace std;
using namespace cv;

#define THD_MAX_SIZE  400.0
#define THD_MAX_RATE  2.0 
#define THD_MIN_RATE  0.3 
extern int g_line1_edge;
extern int g_line2_edge;
extern int g_line3_edge;

int isNewCamera();


void preprocess1(Mat& src1,Mat& src2,Mat& dst1,Mat& dst2, int threshold1, int threshold2)
{
	Mat element = getStructuringElement(MORPH_CROSS,Size(3,3));//5,5
	Mat kernel(3,3,CV_32F,Scalar(-1));
	kernel.at<float>(1,1) = 8.9;
        //int threshold1=31;
        //int threshold2=17;//17;
#ifndef TDR_TRACE
#pragma omp parallel sections
#endif
	{
#ifndef TDR_TRACE
#pragma omp section
#endif
		{
    if( isNewCamera()==1){
                        adaptiveThreshold(src1, dst1, 255, CV_ADAPTIVE_THRESH_MEAN_C, CV_THRESH_BINARY_INV, threshold1,threshold2);//31,17
    }
    else{
                        adaptiveThreshold(src1, dst1, 255, CV_ADAPTIVE_THRESH_MEAN_C, CV_THRESH_BINARY_INV,threshold1, threshold2);//27,18);//29,16);//31,17/37 //31,15, 29,9
    }
			morphologyEx(dst1,dst1,CV_MOP_OPEN,element);
			g_line1_edge = dst1.rows * 0.2;
                        if(g_line1_edge<20) g_line1_edge=20;
			copyMakeBorder(dst1,dst1,g_line1_edge,g_line1_edge,g_line1_edge,g_line1_edge,BORDER_CONSTANT,Scalar(0,0,0));
		}

#ifndef TDR_TRACE
#pragma omp section
#endif
		{
    if( isNewCamera()==1){
                        adaptiveThreshold(src2, dst2, 255, CV_ADAPTIVE_THRESH_MEAN_C, CV_THRESH_BINARY_INV, threshold1,threshold2); //31,17
    }
    else{
                        adaptiveThreshold(src2, dst2, 255, CV_ADAPTIVE_THRESH_MEAN_C, CV_THRESH_BINARY_INV,threshold1, threshold2);//27,18);//29,16); //37
    }
			morphologyEx(dst2,dst2,CV_MOP_OPEN,element);
			g_line2_edge = dst2.rows * 0.2;
                        if(g_line2_edge<20) g_line2_edge=20;
			copyMakeBorder(dst2,dst2,g_line2_edge,g_line2_edge,g_line2_edge,g_line2_edge,BORDER_CONSTANT,Scalar(0,0,0));
		}
	}

}

int card_preprocess_threshold=17;
void preprocess_card(Mat& src1,Mat& src2,Mat& dst1,Mat& dst2)
{
        Mat element = getStructuringElement(MORPH_CROSS,Size(3,3));//5,5
        Mat kernel(3,3,CV_32F,Scalar(-1));
        kernel.at<float>(1,1) = 8.9;
#ifndef TDR_TRACE
#pragma omp parallel sections
#endif
{
#ifndef TDR_TRACE
#pragma omp section
#endif
{
        if( isNewCamera()==1){
               adaptiveThreshold(src1, dst1, 255, CV_ADAPTIVE_THRESH_MEAN_C, CV_THRESH_BINARY_INV, 31, card_preprocess_threshold);// 16);//9);
        }
        else{
               adaptiveThreshold(src1, dst1, 255, CV_ADAPTIVE_THRESH_MEAN_C, CV_THRESH_BINARY_INV, 31,card_preprocess_threshold);//27;17);
        }

        morphologyEx(dst1,dst1,CV_MOP_OPEN,element);
        g_line1_edge = dst1.rows * 0.2;
        if(g_line1_edge<20) g_line1_edge=20;
        copyMakeBorder(dst1,dst1,g_line1_edge,g_line1_edge,g_line1_edge,g_line1_edge,BORDER_CONSTANT,Scalar(0,0,0));
}

#ifndef TDR_TRACE
#pragma omp section
#endif
{
        if( isNewCamera()==1){
               adaptiveThreshold(src2, dst2, 255, CV_ADAPTIVE_THRESH_MEAN_C, CV_THRESH_BINARY_INV, 31, card_preprocess_threshold);//9); 
        }
        else{
               adaptiveThreshold(src2, dst2, 255, CV_ADAPTIVE_THRESH_MEAN_C, CV_THRESH_BINARY_INV,31,card_preprocess_threshold); //27;10
        }
    
        morphologyEx(dst2,dst2,CV_MOP_OPEN,element);
        g_line2_edge = dst2.rows * 0.2;
        if(g_line2_edge<20) g_line2_edge=20;
        copyMakeBorder(dst2,dst2,g_line2_edge,g_line2_edge,g_line2_edge,g_line2_edge,BORDER_CONSTANT,Scalar(0,0,0));
}
}

}


void preprocess_card_one(Mat& src1,Mat& dst1)
{
        Mat element = getStructuringElement(MORPH_CROSS,Size(3,3));//5,5
        Mat kernel(3,3,CV_32F,Scalar(-1));
        kernel.at<float>(1,1) = 8.9;
        if( isNewCamera()==1){
               adaptiveThreshold(src1, dst1, 255, CV_ADAPTIVE_THRESH_MEAN_C, CV_THRESH_BINARY_INV, 31, card_preprocess_threshold);//9);
        }
        else{
               adaptiveThreshold(src1, dst1, 255, CV_ADAPTIVE_THRESH_MEAN_C, CV_THRESH_BINARY_INV, 31,card_preprocess_threshold);
        }

        morphologyEx(dst1,dst1,CV_MOP_OPEN,element);
        g_line3_edge = dst1.rows * 0.2;
        if(g_line3_edge<20) g_line3_edge=20;
        copyMakeBorder(dst1,dst1,g_line3_edge,g_line3_edge,g_line3_edge,g_line3_edge,BORDER_CONSTANT,Scalar(0,0,0));
}


//#endif
