#if 1
#include <ctype.h>
#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <unistd.h>

#include <opencv2/highgui/highgui.hpp>  // OpenCV window I/O
#include <opencv2/imgproc/imgproc.hpp>  // Gaussian Blur

#include "OcrStruct.h"
#include "card_type.h"
#include "tdr_crnn.h"
#include "tdr_ocr.h"
#include "tdrocr.h"
#include "utils.h"
#include "tdr_face_detect.h"
#include "common.h"

#include "passport_visa.h"

using namespace std;
using namespace cv;

extern int g_debug_show;
static int errcount = 0;
static int info_error_cnt = 0;
int total_count = 0;
int stop_on_check_error=0;

int g_model_type = 0;
int g_gen_data = 0;
char g_set_scan_type[20];
int g_camera = 1;  // 0旧摄像头   1新摄像头
int g_use_gpu=0;
int g_test_card=0;
int g_test_face=0;
extern int g_scan_type;
extern int g_scan_none;

// 结果是否需要进行信息校验状态。默认-1，表示不进行校验。
//若是检测到当前代码目录中有校验列表，会自动设置成0，进行校验。
int g_check_ocr_result = -2;
void setTestMode(int mode);
void setFinalCheck(int mode);
void cardMode(int cardclass);
bool isDebugShow();
void setDebugShow(int debug);
void get_extension(const char *file_name, char *extension);
void process_default();
int process_onefile(char *fn);
void process_dir(char *dir_fn, int subdir);
void tdr_set_log_dummy(int onoff);
int init_check_ocr_1(char *path);
int check_ocr_by_read_ocr_info(OCR_RESULT &ocr_result);
int append_valid_region_file(char *filename, char *flag_value);
TextLine crnn_extract_gbk(cv::Mat src);
int get_last_subdir(const char *file_name, char *subdir);
void set_scan_type();
void init_test_info_item();
int test_card(cv::Mat & image);
int tdr_face_detect2(Mat& img, std::vector<s_face_info>& face_info_ls);
int getDetectMode();
void setEdgeCheck(int check);
bool verify(char *);

extern cv::Mat g_rapidRec_line_1;
extern cv::Mat g_rapidRec_line_2;

void get_valid_char_img(cv::Mat &src, std::vector<cv::Rect> roi_rect_list,
                        int line, OCR_RESULT &ocr_result, char *filename);
void get_valid_region_img(cv::Mat &src1, std::vector<cv::Rect> roi_rect_list1,
                          cv::Mat &src2, std::vector<cv::Rect> roi_rect_list2,
                          OCR_RESULT &ocr_result, char *filename);

#ifdef SUPPORT_TEST_CTL
void clear_rotate_status();
int get_rotate_status();
void write_test_info(char *filename);
void init_test_info_item();
int rotated_count = 0;

int check_rotate_status() {
  if (get_rotate_status() == 1) {
    rotated_count++;
    return 1;
  } else
    return 0;
}

int remove_test_file() {
  const char *flag_file_name = "test_info.txt";
  FILE *fp;
  if ((fp = fopen(flag_file_name, "a")) == NULL) {
    printf("write result file error!");
    return -1;
  }
  //std::remove(flag_file_name);
  return 0;
}

#endif

void writeOutputFile(cv::Mat &input, char *filename) {
  int len = strlen(filename);
  char name[200];
  char dirname[200];
  char outputdir[200];
  int first = 0;
  int second = 0;

  for (int i = 0; i < len; i++) {
    if (filename[len - i - 1] == '/') {
      first = len - i - 1;
      memcpy(name, &filename[first + 1], strlen(&filename[first + 1]));
      name[strlen(&filename[first + 1])] = 0x00;
      break;
    }
  }

  for (int i = 0; i < first; i++) {
    if (filename[first - 1 - i] == '/') {
      second = first - 1 - i;
      break;
    }
  }
  memcpy(dirname, &filename[second + 1], first - second - 1);
  dirname[first - second - 1] = 0x00;

  sprintf(outputdir, "output/%s", dirname);
  DIR *mydir;
  if ((mydir = opendir(outputdir)) == NULL)
    mkdir(outputdir, S_IRWXU | S_IRWXG | S_IRWXO);
  else
    closedir(mydir);

  strcat(outputdir, "/");
  strcat(outputdir, name);

  //imwrite(outputdir, input);
  char cmd[500]={0};
  strcat(cmd, "cp ");
  strcat(cmd, filename);
  strcat(cmd, " ");
  strcat(cmd, outputdir);
  //printf("filename: %s\n", filename);
  //printf("write %s\n", outputdir);
  //printf("cmd %s\n", cmd);
  int result = system(cmd);  // 执行ls -l命令
  if(result == -1) {
      // 错误处理
      perror("system cmd error !!!");
      //return 1;
  }

}

void writeInfoErrorFile(cv::Mat &input, char *filename) {
  int len = strlen(filename);
  char name[200];
  char dirname[200];
  char outputdir[200];
  int first = 0;
  int second = 0;

  for (int i = 0; i < len; i++) {
    if (filename[len - i - 1] == '/') {
      first = len - i - 1;
      memcpy(name, &filename[first + 1], strlen(&filename[first + 1]));
      name[strlen(&filename[first + 1])] = 0x00;
      break;
    }
  }

  for (int i = 0; i < first; i++) {
    if (filename[first - 1 - i] == '/') {
      second = first - 1 - i;
      break;
    }
  }
  memcpy(dirname, &filename[second + 1], first - second - 1);
  dirname[first - second - 1] = 0x00;

  sprintf(outputdir, "infoError/%s", dirname);
  DIR *mydir;
  if ((mydir = opendir(outputdir)) == NULL) {
    //mkdir(outputdir, 0777);
    char cmd[200]={0};
    strcat(cmd, "mkdir -p ");
    strcat(cmd, outputdir);
    int result = system(cmd);  // 执行ls -l命令
    if(result == -1) {
        perror("system cmd error !!!");
    }
  }
  else
    closedir(mydir);

  strcat(outputdir, "/");
  strcat(outputdir, name);

  //printf("write %s\n", outputdir);
  
  //imwrite(outputdir, input);
  char cmd[500]={0};
  strcat(cmd, "cp ");
  strcat(cmd, filename);
  strcat(cmd, " ");
  strcat(cmd, outputdir);
  //printf("filename: %s\n", filename);
  printf("write %s\n", outputdir);
  //printf("cmd %s\n", cmd);
  int result = system(cmd);  // 执行ls -l命令
  if(result == -1) {
      // 错误处理
      perror("system cmd error !!!");
      //return 1;
  }

  int outputdirlen = strlen(outputdir);
  int p = outputdirlen;
  for(; p > 0; p-- ){
    if(outputdir[p]=='.')break;
  }
  if(p > 0) {
    char suffix[50]={0};
    strcpy(suffix, outputdir+p);
  }
}

int main_process(char *fn, int isdir) {
#if 0
  char a[100];
  strcpy(a, "EJ29859105");
  bool b=verify(a);
  printf("verify: %s = %s\n", a, b?"true":"false");
#endif
  int ret;
  OCR_RESULT ocr_result;
  // cardMode(1);
  // cardMode(2);
  int mode = g_camera;
  // BGR2NV21(img.data, dst.data, img.cols, img.rows);
  // ret = tdrocr_scan_yuv(dst.data, dst.cols, dst.rows, dst.cols, dst.rows,
  // mode, ocr_result);
  cv::Mat img, img_clone;
#ifdef SUPPORT_TEST_CTL
  clear_rotate_status();
  init_test_info_item();
#endif
  img = cv::imread(fn, 1);
  if (img.empty()) {
    printf("%s is empty\n", fn);
    return -1;
  }
  img_clone = img.clone();

 #ifdef VISA_TRACE
  init_visa_test();
 #endif  

  total_count++;

  if (isDebugShow()) {
    cv::Mat showmat;
    int resize_x = 480;
    int resize_y = (float)img.rows / (float)img.cols * 480;
    cv::resize(img, showmat, cv::Size(resize_x, resize_y), 0, 0, INTER_NEAREST);
    cv::imshow("src", showmat);
  }

  if(g_test_card==1) return test_card(img);

  if(g_test_face==1)
  {
     cv::Mat face;
     cv::Rect rectFace;
     std::vector<s_face_info> face_info_ls;
     ret=tdr_face_detect2(img, face_info_ls);
     cv::Mat showmat= img.clone();
     if(ret>0){
        for (int i = 0; i < face_info_ls.size(); ++i) {
            cv::rectangle(showmat, cv::Rect(face_info_ls[i].rect.x, face_info_ls[i].rect.y, face_info_ls[i].rect.width, face_info_ls[i].rect.height), cv::Scalar(0, 0, 255), 1);
        }
     }
     cv::imshow("face", showmat);
     cv::waitKey(0);
     return ret;
  }

  for (int i = 0; i < 1; i++) {
    if (g_model_type > 0 && img.rows < 100) {
      ret = -1;
      if (g_model_type == MODEL_TYPE_GBK) {
        TextLine tl = crnn_extract_gbk(img);
        printf("[%s]\n", tl.text.c_str());
      } else if (g_model_type == MODEL_TYPE_CN) {
        TextLine tl = crnn_extract_cn(img);
        printf("[%s]\n", tl.text.c_str());
      } else if (g_model_type == MODEL_TYPE_MRZ ||
                 g_model_type == MODEL_TYPE_EN) {
        TextLine tl;
        if (g_model_type == MODEL_TYPE_EN)
          tl = crnn_extract_en(img, 'O');
        else if (g_model_type == MODEL_TYPE_MRZ)
          tl = crnn_extract_mrz(img, 'O');
        char subdir[200];
        int subdir_len = get_last_subdir(fn, subdir);
        if (subdir_len == 1 && ((subdir[0] >= '0' && subdir[0] <= '9') ||
                                (subdir[0] >= 'A' && subdir[0] <= 'Z'))) {
          if (tl.text.length() == 1 && tl.text[0] == subdir[0]) {
            ret = 0;
          }
        } else if (subdir_len == 2 && subdir[0] == 'A' && subdir[1] == 'A') {
          if (tl.text.length() == 1 && tl.text[0] == '<') {
            ret = 0;
          }
        } else if (subdir_len == 2 && subdir[0] == 'B' && subdir[1] == 'B') {
        }
        printf("[%s]\n", tl.text.c_str());
      }
    } else {
      ret = tdrocr_scan_mat(img, mode, ocr_result);
      if(g_scan_type==99){
          if(ret<0) ret = tdrocr_scan_mat(img, mode, ocr_result);
      }
      else if( getDetectMode()==0){
          if(ret<0) ret = tdrocr_scan_mat(img, mode, ocr_result);
          if(ret<0) ret = tdrocr_scan_mat(img, mode, ocr_result);
      }

      //if(!ocr_result.faceimg.empty()) ocr_result.faceimg.release();
      //if(!ocr_result.cropimg.empty()) ocr_result.cropimg.release();
      ////////////////say///////////////////////
#ifdef DATA_GEN
      if (g_gen_data == 1 && ret == 0 &&
          (ocr_result.certificate_type == CERTIFICATE_TYPE_PASSPORT ||
           ocr_result.certificate_type == CERTIFICATE_TYPE_VISA ||
           ocr_result.certificate_type == CERTIFICATE_TYPE_RESIDENT)) {
        get_valid_char_img(g_rapidRec_line_1, g_posRect1_rgb, 1, ocr_result,
                           fn);
        get_valid_char_img(g_rapidRec_line_2, g_posRect2_rgb, 2, ocr_result,
                           fn);
        get_valid_region_img(g_rapidRec_line_1, g_posRect1_rgb,
                             g_rapidRec_line_2, g_posRect2_rgb, ocr_result, fn);
      }
#endif
      //////////////////////////////////////
    }
#ifdef SUPPORT_TEST_CTL
    append_test_info_item("执行结果: ", ret);
#endif
    if (ret == 0) {
      if (0 != g_check_ocr_result/*init_check_ocr_1("./")*/) {
        //printf(" !!! 未进行信息校验 !!!\n");

#ifdef SUPPORT_TEST_CTL
        //append_test_info_item("不支持信息校验", NO_TEST_PARA);
#endif
      } else {
        
#ifdef VISA_TRACE 
        recordFile(fn, "record_vis_no", "_no_cut", g_vis_no_cut);
        recordFile(fn, "record_vis_no", "_no_colort", g_vis_no_color);

        recordFile(fn, "record_visa_category", "_category_cut_1", g_visa_category_cut_1);
        recordFile(fn, "record_visa_category", "_category_cut_2", g_visa_category_cut_2);
        recordFile(fn, "record_visa_category", "_category_detect", g_visa_category_detect);
#endif
        
        if (0 != check_ocr_by_read_ocr_info(ocr_result)) {
          if (isdir > 0) writeInfoErrorFile(img_clone, fn);
          info_error_cnt++;
          printf(">>> 信息校验错误 <<<\n");
#ifdef SUPPORT_TEST_CTL
          append_test_info_item("信息校验失败", NO_TEST_PARA);
#endif
          ret = -1111;
        } else {
#ifdef SUPPORT_TEST_CTL
          append_test_info_item("信息校验成功", NO_TEST_PARA);
#endif
        }
      }
      break;
    }
  }

  //printf("ocr return = %d \n", ret);
  if (ret == ERROR_LOCATION) {
    printf(">>> 证件没放好 <<<\n");
  }
  else if(ret==ERROR_DOC_TYPE)
  {
    printf(">>> 证件不支持 <<<\n");
  }

  printf("--------------------\n\n");

  if (ret != 0) {
    if (isdir > 0) writeOutputFile(img_clone, fn);
    errcount = errcount + 1;
  }
// printf("error count = %d\n", errcount);
#ifdef SUPPORT_TEST_CTL
  if (check_rotate_status()) {
    append_test_info_item("字符行定位需要再次校正图片", NO_TEST_PARA);
  }

  write_test_info(fn);
#endif
#ifdef TDR_TRACE
  //if(ret!=0) cv::waitKey(0);
  //if(abs(ret)>90 && abs(ret)<99) cv::waitKey(0);
  if (stop_on_check_error==1 && ret==-1111) cv::waitKey(0);
  else if (stop_on_check_error==0 && isDebugShow()) cv::waitKey(0);
#endif

  return ret;
}

int init(int camera) {
  int ret = tdrocr_init("../models-release", g_use_gpu==1?"opencl":"", camera);
  return ret;
}

int uninit() {
  tdrocr_unInit();
  return 0;
}

int main(int argc, char *argv[]) {
  int ret;
  int i;
  std::string fn1;
  int include_subdir = 0;
  if (argc < 2) {
    printf(
        "Usages: ./tdrocr -m0/-m1 -r -s0/-s1 [file]/[dir] \n\
-m: m0,old_camera, m1: new_camera \n\
-r: include_subdirectory \n\
-s0: no_debug_output, -s1 debug_output \n\
-c1: 台湾/香港来大陆通行证, -c2 去往台湾香港通行证 \n\
-en/-mrz/-cn/-gbk: 使用指定的字符集识别，输入为一行文本的图像 \n\
-gen: 护照识别成功后，将识别的字符分割保存成图片 \n\
-ai: 护照识别时强制使用ai算法 \n\
\n");
    return 0;
  }

  setDebugShow(1);
  setTestMode(1);
  tdr_set_log_dummy(0);
#ifdef ANDROID
  tdr_set_log_file("log.txt");
#endif
  cardMode(1);  // 来大陆通行证

  for (i = 1; i < argc; i++) {
    if (strcmp(argv[i], "-m0") == 0) {
      g_camera = 0;
    } else if (strcmp(argv[i], "-m1") == 0) {
      g_camera = 1;
    } else if (strcmp(argv[i], "-r") == 0) {
      include_subdir = 1;
    } else if (strcmp(argv[i], "-s0") == 0) {
      setDebugShow(0);
    } else if (strcmp(argv[i], "-s1") == 0) {
      setDebugShow(1);
    } else if (strcmp(argv[i], "-d0") == 0) {
      tdr_set_log_dummy(1);
    } else if (strcmp(argv[i], "-d1") == 0) {
      tdr_set_log_dummy(0);
    } else if (strcmp(argv[i], "-c1") == 0) {
      cardMode(1);
    } else if (strcmp(argv[i], "-c2") == 0) {
      cardMode(2);
    } else if (strcmp(argv[i], "-cn") == 0) {
      g_model_type = MODEL_TYPE_CN;
    } else if (strcmp(argv[i], "-en") == 0) {
      g_model_type = MODEL_TYPE_EN;
    } else if (strcmp(argv[i], "-env3") == 0) {
      g_model_type = MODEL_TYPE_EN_V3;
    } else if (strcmp(argv[i], "-mrz") == 0) {
      g_model_type = MODEL_TYPE_MRZ;
    } else if (strcmp(argv[i], "-gbk") == 0) {
      g_model_type = MODEL_TYPE_GBK;
    } else if (strcmp(argv[i], "-gen") == 0) {
      g_gen_data = 1;
    } else if (strcmp(argv[i], "-ai") == 0) {
      //set_force_ai(1);
    } else if (strcmp(argv[i], "-gpu") == 0) {
      g_use_gpu=1;
    } else if (strcmp(argv[i], "-nocheck") == 0) {
      g_check_ocr_result=-2;
    } else if (strcmp(argv[i], "-check") == 0) {
      g_check_ocr_result=-1;

    } else if (strcmp(argv[i], "-nofinalcheck") == 0) {
      setFinalCheck(0);
    } else if (strcmp(argv[i], "-noedgecheck") == 0) {
      setEdgeCheck(0);
    } else if (strcmp(argv[i], "-edgecheck") == 0) {
      setEdgeCheck(1);
    } else if (strcmp(argv[i], "-stop") == 0) {
      stop_on_check_error=1;
    } else if (strcmp(argv[i], "-test") == 0) {
      setTestMode(1);
    } else if (strcmp(argv[i], "-notest") == 0) {
      setTestMode(0);
    } else if (strcmp(argv[i], "-det1") == 0) {
      setDetectMode(1);
    } else if (strcmp(argv[i], "-det2") == 0) {
      setDetectMode(2);
    } else if (strcmp(argv[i], "-det3") == 0) {
      strcpy(g_set_scan_type, "-st99");   
    } else if (strncmp(argv[i], "-st", 3) == 0) {
      //-st提示输入 -st0~9则选择0~9
      strcpy(g_set_scan_type, argv[i]);
    } else if (strcmp(argv[i], "-card") == 0) {
      g_test_card=1;
    } else if (strcmp(argv[i], "-face") == 0) {
      g_test_face=1;
    } else if (strcmp(argv[i], "-none") == 0) {
      g_scan_none=1;
    } else {
      fn1 = std::string(argv[i]);
    }
  }

  if (fn1.length() == 0) {
    printf("no filename given. \n");
    return 0;
  }

  ret = init(g_camera);
  if (ret != 0) {
    printf("init fail %d, exit!\n", ret);
    return ret;
  }

  if(g_check_ocr_result!=-2)  g_check_ocr_result = init_check_ocr_1("./");
#ifdef SUPPORT_TEST_CTL
  remove_test_file();
#endif

  set_scan_type();

  struct stat st;
  if ((fn1.length() > 0) && stat(fn1.c_str(), &st) == 0) {
    if (S_ISREG(st.st_mode)) {
      process_onefile((char *)fn1.c_str());
    } else {
      process_dir((char *)fn1.c_str(), include_subdir);
    }
  }

  printf(">>>> error/total = %d/%d <<<<\n", errcount, total_count);
  printf(">>>> info_error_cnt/total = %d/%d <<<<\n", info_error_cnt, total_count);
#ifdef SUPPORT_TEST_CTL
  printf(">>>> rotated_count/total = %d/%d <<<<\n", rotated_count, total_count);
#endif

  uninit();
  printf("end\n");
  return 0;
}

void get_extension(const char *file_name, char *extension) {
  int found = -1;
  int i;
  for (i = strlen(file_name) - 1; i >= 0; i--) {
    if (file_name[i] == '.') {
      found = i;
      break;
    } else if (file_name[i] == '/') {
      break;
    }
  }

  if (found >= 0)
    strcpy(extension, file_name + found + 1);
  else
    strcpy(extension, "\0");
  for (i = 0; i < strlen(extension); i++) {
    extension[i] = tolower(extension[i]);
  }
}

int process_onefile(char *fn) {
  char ext_name[128];
  get_extension(fn, ext_name);
  if (strlen(ext_name) == 0) return -1;
  if (strcmp(ext_name, "jpg") == 0 || strcmp(ext_name, "bmp") == 0 ||
      strcmp(ext_name, "png") == 0 || strcmp(ext_name, "jpeg") == 0 ||
      strcmp(ext_name, "tiff") == 0 || strcmp(ext_name, "webp") == 0) {
    printf("\n-----------------------------------------\n");
    printf("%s\n", fn);
    printf("-----------------------------------------\n");
    main_process(fn, 0);
    return 0;
  }
  return -1;
}

void process_dir(char *dir_fn, int subdir) {
  DIR *dir = opendir(dir_fn);
  struct dirent *dirp;
  char filename1[512];
  if (dir == NULL) {
    return;
  }

  DIR *mydir;
  if ((mydir = opendir("output")) == NULL)
    mkdir("output", S_IRWXU | S_IRWXG | S_IRWXO);
  else
    closedir(mydir);

  while ((dirp = readdir(dir)) != NULL) {
    if (strcmp(dirp->d_name, ".") == 0 || strcmp(dirp->d_name, "..") == 0 ||
        strcmp(dirp->d_name, ".DS_Store") == 0)
      continue;
    if (dirp->d_type == DT_REG || dirp->d_type == DT_DIR) {
      sprintf(filename1, "%s/%s", dir_fn, dirp->d_name);
      char ext_name[128];
      get_extension(filename1, ext_name);
      if (strcmp(ext_name, "jpg") == 0 || strcmp(ext_name, "bmp") == 0 ||
          strcmp(ext_name, "png") == 0 || strcmp(ext_name, "jpeg") == 0 ||
          strcmp(ext_name, "tiff") == 0 || strcmp(ext_name, "webp") == 0) {
        printf("\n-----------------------------------------\n");
        printf("%s\n", filename1);
        printf("-----------------------------------------\n");
        main_process(filename1, 1);

      } else if (subdir == 1) {
        process_dir(filename1, subdir);
      }
    }
  }

  closedir(dir);
}

void set_scan_type()
{
      int scan_type = 0x0FF;
      if ( strlen(g_set_scan_type)>3){
          scan_type=atoi(&g_set_scan_type[3]);
          printf("scan_type: %d\n", scan_type);
          tdrocr_set_scan_type(scan_type);
      }
      else if( strlen(g_set_scan_type)==3)
      {
          bool set_is_ok = false;
          while (1) {
            printf(" select scan_type from:\n");
            printf(" 0: 自适应模式\n");
            printf(" 1: 护照模式\n");
            printf(" 3: 香港来内地模式\n");
            printf(" 4: 台湾来内地模式\n");
            printf(" 7: 签证模式\n");
            printf(" 8: 外国人居留许可模式\n");

            cin >> scan_type;
            switch (scan_type) {
              case CERTIFICATE_TYPE_DEFAULT:   // 0
              case CERTIFICATE_TYPE_PASSPORT:  // 1 护照
              // case CERTIFICATE_TYPE_ID:        // 2
              case CERTIFICATE_TYPE_FROM_HM:  // 3 香港来内地
              case CERTIFICATE_TYPE_FROM_TW:  // 4 台湾来内地
              // case CERTIFICATE_TYPE_TO_HM:     // 5
              // case CERTIFICATE_TYPE_TO_TW:     // 6
              case CERTIFICATE_TYPE_VISA:      // 7 签证
              case CERTIFICATE_TYPE_RESIDENT:  // 8 外国人居留许可
                set_is_ok = true;
                break;
              default:
                break;
            }
            if (set_is_ok) break;
          }
          tdrocr_set_scan_type(scan_type);
      }
}

#endif
