#include "card_type.h"
#include "common.h"
#include <string>
#include <fstream>
#include "tdrocr.h"


#include "passport_visa.h"


typedef struct TEST_OCR_RESULT
{
    char certificate_name[48]; //证件名称(中文)
    char id[32];         //证件号码
    char name[32];       //中文姓名
    char name_en[40];    //英文姓名
    char nationality[32];//国籍
    char ethnicity[16];  //民族
    char address[64];    //住址
    char birthday[32];   //xxxxxxxx
    char birth_at[32];   //出生地
    char sex[8];        //中文
    char valid_from[16]; //xxxxxxxx
    char valid_to[16];   //xxxxxxxx
    char issue_date[16]; //xxxxxxxx
    char issue_by[32];   //发证机关
    char issue_at[32];   //签发地
    char issue_country[32]; //签发国(中文)
    char issue_count[16]; //签发次数
    char add_id[32];   //右上角的证件号
    char category[16];  //签证种类

    char mrz[100]; //机读区

}TEST_OCR_RESULT;

using namespace std;
vector<TEST_OCR_RESULT> ocr_info_list;
void display_cur_ocr(TEST_OCR_RESULT & ocr_result);
int read_ocr_info( char* file_name);

void clear_test_ocr_result(TEST_OCR_RESULT & ocr_result)
{
    ocr_result.certificate_name[0] = 0; //证件名称(中文)
    ocr_result.id[0] = 0;         //证件号码
    ocr_result.name[0] = 0;       //中文姓名
    memset(ocr_result.name, 0,32);
    ocr_result.name_en[0] = 0;    //英文姓名
    memset(ocr_result.name_en, 0,40);
    ocr_result.nationality[0] = 0;//国籍
    ocr_result.ethnicity[0] = 0;  //民族
    ocr_result.address[0] = 0;    //住址
    ocr_result.birthday[0] = 0;   //xxxxxxxx
    ocr_result.birth_at[0] = 0;   //出生地
    ocr_result.sex[0] = 0;        //中文
    ocr_result.valid_from[0] = 0; //xxxxxxxx
    ocr_result.valid_to[0] = 0;   //xxxxxxxx
    ocr_result.issue_date[0] = 0; //xxxxxxxx
    ocr_result.issue_by[0] = 0;   //发证机关
    ocr_result.issue_at[0] = 0;   //签发地
    ocr_result.issue_country[0] = 0; //签发国(中文)
    ocr_result.issue_count[0] = 0; //签发次数
    ocr_result.add_id[0] = 0;   //右上角的证件号
    ocr_result.category[0] = 0;  //签证种类

    ocr_result.mrz[0] = 0; //机读区
}

int init_check_ocr_1 (char* path)
{
  char check_ocr_file_path[300]={0};
  const char * file_name = "test_ocr_result.txt";

  int len = strlen(path);
  int i = 0;  
  char split[] = "/";
  for(i = len; i > 0; i--) {
      if((char*)split[0] == (char*)path[i]) {  
        break;
      }
  }
  if(i == 0)
    return -1;
//printf("path=%s\n", path);  
  memcpy(check_ocr_file_path, path, i);
  check_ocr_file_path[strlen(path)]=0x00;
  strcat(check_ocr_file_path, "/");
  strcat(check_ocr_file_path, file_name);
//LOGI("init_check_ocr : %s", check_ocr_file_path );
  return read_ocr_info( check_ocr_file_path); 
}

void display_cur_ocr(TEST_OCR_RESULT & ocr_result)
{ 
  LOGD("-------------------------------------------");
  if(0 != ocr_result.certificate_name[0])
    LOGD("certificate_name : %s", ocr_result.certificate_name );
  if(0 != ocr_result.id[0])
    LOGD("id : %s", ocr_result.id );
  if(0 != ocr_result.name[0])
    LOGD("name : %s", ocr_result.name );
  if(0 != ocr_result.name_en[0])
    LOGD("name_en : %s", ocr_result.name_en );
  if(0 != ocr_result.nationality[0])
    LOGD("nationality : %s", ocr_result.nationality );
  if(0 != ocr_result.ethnicity[0])
    LOGD("ethnicity : %s", ocr_result.ethnicity );
  if(0 != ocr_result.address[0])
    LOGD("address : %s", ocr_result.address );
  if(0 != ocr_result.birthday[0])
    LOGD("birthday : %s", ocr_result.birthday );
  if(0 != ocr_result.birth_at[0])
    LOGD("birth_at : %s", ocr_result.birth_at );
  if(0 != ocr_result.sex[0])
    LOGD("sex : %s", ocr_result.sex );
  if(0 != ocr_result.valid_from[0])
    LOGD("valid_from : %s", ocr_result.valid_from );
  if(0 != ocr_result.valid_to[0])
    LOGD("valid_to : %s", ocr_result.valid_to );
  if(0 != ocr_result.issue_date[0])
    LOGD("issue_date : %s", ocr_result.issue_date );
  if(0 != ocr_result.issue_by[0])
    LOGD("issue_by : %s", ocr_result.issue_by );
#ifdef USE_ISSUER_ADDR    
  if(0 != ocr_result.issue_at[0])
    LOGD("issue_at : %s", ocr_result.issue_at );
#endif    
  if(0 != ocr_result.issue_country[0])
    LOGD("issue_country : %s", ocr_result.issue_country );
  if(0 != ocr_result.issue_count[0])
    LOGD("issue_count : %s", ocr_result.issue_count );
  if(0 != ocr_result.add_id[0]) 
    LOGD("add_id : %s", ocr_result.add_id );
  if(0 != ocr_result.category[0])
    LOGD("category : %s", ocr_result.category );
   if(0 != ocr_result.mrz[0])
    LOGD("mrz : %s %d", ocr_result.mrz, strlen(ocr_result.mrz) );   

}

int read_ocr_info(char* file_name)
{
    //LOGD("-----------read_ocr_info-------------" );
    //clearOcrResult(ocr_info);

    std::fstream fin(file_name, std::ios::in | std::ios::binary);
    if(!fin) {
        //LOGD("open in file [%s] error", file_name);
        return -1;
    }

    char s[100];
    char split_char[] = ":";
    char *item = NULL;
    char *result = NULL;
    const char *item_start = "item_start:"; 
    const char *item_end = "item_end."; 
    TEST_OCR_RESULT ocr_info;
    vector<TEST_OCR_RESULT>().swap(ocr_info_list);
    int record_status = 0;

    while(fin.getline((char *)&s[0],100)) { //一直读到文件结束  
        //std::cout << s <<std::endl; // 打印每一行
        // 找条目
        int len = strlen(s);
        if(len > 4 && 0==memcmp(s, item_start, strlen(item_start))) {
          record_status =1;
          clear_test_ocr_result(ocr_info);
          continue;
        } 
        if(len > 4 && 0==memcmp(s, item_end, strlen(item_end))) {
          ocr_info_list.push_back(ocr_info);
          record_status = 0;
          continue;
        } 
        // 空行
        if(len == 0) continue;  

        item = strtok(s, split_char);
        result = strtok(NULL, split_char);

        int item_len = strlen(item);
        int result_len = strlen(result);
        
        int i = 0;
        while(i < item_len) {
            item[i] = tolower(item[i]);
            i++;
        }
        i = 0;
        while(i < result_len) {
            result[i] = toupper(result[i]);
            i++;
        }
        //LOGD("-----------------------------%s %s %d %d", item, result, item_len, result_len);
        
        if(item_len > 0 && result_len > 0 &&  record_status==1) {

          if(0 == strcmp("certificate_name", item))
              strcpy(ocr_info.certificate_name, result);
          if(0 == strcmp("id", item))
              strcpy(ocr_info.id, result);
          if(0 == strcmp("name", item))
              strcpy(ocr_info.name, result);
          if(0 == strcmp("name_en", item)) {
              // 长度非固定值需要特殊处理
              if(result_len > 40) {
                  memcpy(ocr_info.name_en, result, 40);
                  LOGD("real name_en = %s", ocr_info.name_en);
              }
              else
                  strcpy(ocr_info.name_en, result);
          }
          if(0 == strcmp("nationality", item))
              strcpy(ocr_info.nationality, result);
          if(0 == strcmp("ethnicity", item))
              strcpy(ocr_info.ethnicity, result);
          if(0 == strcmp("address", item))
              strcpy(ocr_info.address, result);
          if(0 == strcmp("birthday", item))
              strcpy(ocr_info.birthday, result);
          if(0 == strcmp("birth_at", item))
              strcpy(ocr_info.birth_at, result);
          if(0 == strcmp("sex", item))
              strcpy(ocr_info.sex, result);
          if(0 == strcmp("valid_from", item))
              strcpy(ocr_info.valid_from, result);
          if(0 == strcmp("valid_to", item))
              strcpy(ocr_info.valid_to, result);
          if(0 == strcmp("issue_date", item))
              strcpy(ocr_info.issue_date, result);
          if(0 == strcmp("issue_by", item))
              strcpy(ocr_info.issue_by, result);
          if(0 == strcmp("issue_at", item))
              strcpy(ocr_info.issue_at, result);
          if(0 == strcmp("issue_country", item))
              strcpy(ocr_info.issue_country, result);
          if(0 == strcmp("issue_count", item))
              strcpy(ocr_info.issue_count, result);
          if(0 == strcmp("add_id", item))
              strcpy(ocr_info.add_id, result);
          if(0 == strcmp("category", item))
              strcpy(ocr_info.category, result);
          if(0 == strcmp("mrz", item))
              strcpy(ocr_info.mrz, result);
        }

    }
    LOGD(" check_info_cnt:  %d", ocr_info_list.size());
    return 0;
}

int check_ocr_result( OCR_RESULT & ocr_result, TEST_OCR_RESULT & ocr_info)
{
    if(0 != ocr_info.id[0]) {
        if(0 != strcmp(ocr_result.id, ocr_info.id)
          || strlen(ocr_result.id) != strlen(ocr_info.id)){
            //LOGD("id error : %s != %s", ocr_info.id, ocr_result.id );
            return -1;
        }    
    }
    if(0 != ocr_info.name[0]) {
        int i, len1, len2;
        for(i = 31; i >= 0; i--){
            if(ocr_info.name[i] == 0)
                break;
        }
        len1 = i+1;
        for(i = 31; i >= 0; i--){
            if(ocr_result.name[i] == 0)
                break;
        }
        len2 = i+1;

        if(0 != memcmp(ocr_result.name, ocr_info.name, len1)
          || len1 != len2){
            //LOGD("name error : %s != %s", ocr_info.name, ocr_result.name);
            return -1;
        }    
    }
    if(0 != ocr_info.name_en[0]) {// 名字长的也是仅取32字节 进行判断
        if(0 != strcmp(ocr_result.name_en, ocr_info.name_en)
          || strlen(ocr_result.name_en) != strlen(ocr_info.name_en)){
            LOGD("name_en error : %s != %s", ocr_info.name_en, ocr_result.name_en );
            LOGD("name_en error : %d != %d", strlen(ocr_result.name_en), strlen(ocr_info.name_en) );
            return -1;
        }    
    }

    if(0 != ocr_info.certificate_name[0]) {
        if(0 != strcmp(ocr_result.certificate_name, ocr_info.certificate_name)
          || strlen(ocr_result.certificate_name) != strlen(ocr_info.certificate_name)){
            LOGD("certificate_name error : %s != %s", ocr_info.certificate_name, ocr_result.certificate_name );
            return -1;
        }
    }


    if(0 != ocr_info.nationality[0]) {
        if(0 != strcmp(ocr_result.nationality, ocr_info.nationality)
          || strlen(ocr_result.nationality) != strlen(ocr_info.nationality)){
            LOGD("nationality error : %s != %s", ocr_info.nationality, ocr_result.nationality );
            return -1;
        }    
    }
    if(0 != ocr_info.ethnicity[0]) {
        if(0 != strcmp(ocr_result.ethnicity, ocr_info.ethnicity)
          || strlen(ocr_result.ethnicity) != strlen(ocr_info.ethnicity)){
            LOGD("ethnicity error : %s != %s", ocr_info.ethnicity, ocr_result.ethnicity );
            return -1;
        }    
    }
    if(0 != ocr_info.address[0]) {
        if(0 != strcmp(ocr_result.address, ocr_info.address)
          || strlen(ocr_result.address) != strlen(ocr_info.address)){
            LOGD("address error : %s != %s", ocr_info.address, ocr_result.address );
            return -1;
        }    
    }
    if(0 != ocr_info.birthday[0]) {
        if(0 != strcmp(ocr_result.birthday, ocr_info.birthday)
          || strlen(ocr_result.birthday) != strlen(ocr_info.birthday)){
            LOGD("birthday error : %s != %s", ocr_info.birthday, ocr_result.birthday );
            return -1;
        }    
    }
    if(0 != ocr_info.birth_at[0]) {
        if(0 != strcmp(ocr_result.birth_at, ocr_info.birth_at)
          || strlen(ocr_result.birth_at) != strlen(ocr_info.birth_at)){
            LOGD("birth_at error : %s != %s", ocr_info.birth_at, ocr_result.birth_at );
            return -1;
        }    
    }
    if(0 != ocr_info.sex[0]) {
        if(0 != strcmp(ocr_result.sex, ocr_info.sex)
          || strlen(ocr_result.sex) != strlen(ocr_info.sex)){
            LOGD("sex error : %s != %s", ocr_info.sex, ocr_result.sex );
            return -1;
        }    
    }
    if(0 != ocr_info.valid_from[0]) {
        if(0 != strcmp(ocr_result.valid_from, ocr_info.valid_from)
          || strlen(ocr_result.valid_from) != strlen(ocr_info.valid_from)){
            LOGD("valid_from error : %s != %s", ocr_info.valid_from, ocr_result.valid_from );
            return -1;
        }    
    }
    if(0 != ocr_info.valid_to[0]) {
        if(0 != strcmp(ocr_result.valid_to, ocr_info.valid_to)
          || strlen(ocr_result.valid_to) != strlen(ocr_info.valid_to)){
            LOGD("valid_to error : %s != %s", ocr_info.valid_to, ocr_result.valid_to );
            return -1;
        }    
    }
     if(0 != ocr_info.issue_date[0]) {
        if(0 != strcmp(ocr_result.issue_date, ocr_info.issue_date)
          || strlen(ocr_result.issue_date) != strlen(ocr_info.issue_date)){
            LOGD("issue_date error: %s != %s", ocr_info.issue_date, ocr_result.issue_date );
            return -1;
        }    
    }
     if(0 != ocr_info.issue_by[0]) {
        if(0 != strcmp(ocr_result.issue_by, ocr_info.issue_by)
          || strlen(ocr_result.issue_by) != strlen(ocr_info.issue_by)){
            LOGD("issue_by error : %s != %s", ocr_info.issue_by, ocr_result.issue_by );
            return -1;
        }    
    }
    
#ifdef USE_ISSUER_ADDR      
     if(0 != ocr_info.issue_at[0]) {
        if(0 != strcmp(ocr_result.issue_at, ocr_info.issue_at)
          || strlen(ocr_result.issue_at) != strlen(ocr_info.issue_at)){
            LOGD("issue_at error : %s != %s", ocr_info.issue_at, ocr_result.issue_at );
            return -1;
        }    
    }
#endif    
     if(0 != ocr_info.issue_country[0]) {
        if(0 != strcmp(ocr_result.issue_country, ocr_info.issue_country)
          || strlen(ocr_result.issue_country) != strlen(ocr_info.issue_country)){
            LOGD("issue_country error : %s != %s", ocr_info.issue_country, ocr_result.issue_country );
            return -1;
        }    
    }
     if(0 != ocr_info.issue_count[0]) {
        if(0 != strcmp(ocr_result.issue_count, ocr_info.issue_count)
          || strlen(ocr_result.issue_count) != strlen(ocr_info.issue_count)){
            LOGD("issue_count error : %s != %s", ocr_info.issue_count, ocr_result.issue_count );
            return -1;
        }    
    }
     if(0 != ocr_info.add_id[0]) {
        if(0 != strcmp(ocr_result.add_id, ocr_info.add_id)
          || strlen(ocr_result.add_id) != strlen(ocr_info.add_id)){
            LOGD("add_id error : %s != %s", ocr_info.add_id, ocr_result.add_id );
            return -1;
        }    
    }
     if(0 != ocr_info.category[0]) {
        if(0 != strcmp(ocr_result.category, ocr_info.category)
          || strlen(ocr_result.category) != strlen(ocr_info.category)){
            LOGD("category error : %s != %s", ocr_info.category, ocr_result.category );
            return -1;
        }    
    }
     if(0 != ocr_info.mrz[0]) {
        if(0 != strcmp(ocr_result.mrz, ocr_info.mrz)
          || strlen(ocr_result.mrz) != strlen(ocr_info.mrz)){
            LOGD("%d %d", strlen(ocr_result.mrz), strlen(ocr_info.mrz));
            LOGD("mrz mismatch:");
            LOGD("%s", ocr_result.mrz);
            LOGD("%s", ocr_info.mrz);
            return -1;
        }    
    }
 

  return 0;
}


int check_ocr_by_read_ocr_info(OCR_RESULT & ocr_result )
{   
  int ret = -1;
 
    for(int i = 0; i <ocr_info_list.size() ; i++) {
      TEST_OCR_RESULT  ocr_info = ocr_info_list[i];
      //display_cur_ocr(ocr_info);
      
      ret = check_ocr_result(ocr_result, ocr_info);
      //printf("cor_info[%d] result: %d\n", i, ret);
      if(ret == 0)break;
    }
  
  return ret;
}

#ifdef SUPPORT_TEST_CTL
int g_need_rotate = 0;
char test_info_item_array[2000];
int test_info_item_pos = 0;
int append_valid_region_file(char *filename, char *flag_value);

void set_rotate_status() { g_need_rotate = 1; }
int append_test_info_item(char *flag_name, int flag_value) {
  char cur_flag_array[500];
  strcpy(cur_flag_array, flag_name);
  if (NO_TEST_PARA != flag_value) {
    strcat(cur_flag_array, std::to_string(flag_value).c_str());
  }
  strcat(cur_flag_array, "\t");
  int len = strlen(cur_flag_array);
  if (len + test_info_item_pos >= 800) {
    LOGD("测试信息超过缓冲区");
    return -1;
  }
  LOGD("%s", cur_flag_array);

  memcpy(test_info_item_array + test_info_item_pos, cur_flag_array, len);
  test_info_item_pos += len;

  return 0;
}

void clear_rotate_status() { g_need_rotate = 0; }
int get_rotate_status(){ return g_need_rotate;}

void write_test_info(char *filename) {
  const char *flag_file_name = "test_info.txt";
  append_test_info_item(filename, NO_TEST_PARA);
  test_info_item_array[test_info_item_pos] = 0;

  append_valid_region_file((char *)flag_file_name, test_info_item_array);
}

void init_test_info_item() { test_info_item_pos = 0; }

#endif
